         title   ExtractDlg - Normal Window with (.rc)

         .586
         .model flat, stdcall
         option casemap:none   ; Case sensitive

            include  \MASM32V1\PROGRAMS\AsmEdit\include\windows.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\user32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\GDI32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\kernel32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\comdlg32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\COMCTL32.inc

   include  \MASM32V1\PROGRAMS\AsmEdit\include\DSPMACRO.asm

BaseAscii      PROTO  :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

MOVmd    MACRO Var1, Var2
          push     Var2
           pop     Var1
          ENDM

MOVmw    MACRO Var1, Var2
      pushad 
         lea     esi, Var2
         lea     edi, Var1
         repeat     2
            mov     al, [esi]
            mov     [edi], al
            inc     esi
            inc     edi
         ENDM
        popad
         ENDM

.data
FontName       db  'Courier New',0
AppName        db  'Extract Resources',0

szError7       db  'There are no dialogs'
               db  0Dh,0Ah
               db  'for the requested file.',0
szError8       db  'There are no resources'
               db  0Dh,0Ah
               db  'for the requested file.',0

;szDlgNum       db  2 dup(' ')
;               db  '  Dialog(s) have been extracted.',0dh,0ah
;szCtrlNum      db  2 dup(' ')
;               db  '  Controls(s) have been extracted.',0dh,0ah,0

szAccess       db  'This program is in use.'
               db  0Dh,0Ah
               db  'Would you like to open it as read only ?',0

szTitleO       db  'Read File',0
szPE           db  'Files Types(*.exe), (*.dll), (*.res), (*.scr)',0,'*.exe;*.dll;*.res;*.scr',0,
                   'All Files',0,'*.*',0,0

szDlg          db  ' DIALOG LOADONCALL MOVEABLE DISCARDABLE ',0
szDlgEX        db  ' DIALOGEX LOADONCALL MOVEABLE DISCARDABLE ',0
szCapt         db  'CAPTION ',0
szFont         db  'FONT    ',0  
szSty          db  'STYLE   ',0  
szEXSty        db  'EXSTYLE ',0
szBegin        db  'BEGIN',0dh,0ah,0
szCont         db  '    CONTROL ',0
szEnd          db  'END',0dh,0ah,0
szx            db  '0x',0
szQuote        db  '"',0
szCRLF         db  0dh,0ah,0
szComma        db  ',',0
szSpace        db  ' ',0
szMinus1       db  '-1'
szNULL         db  0

ButtClass      db  'button',0
EditClass      db  'edit',0
StaticClass    db  'static',0
ListboxClass   db  'listbox',0
ScrollClass    db  'scrollbar',0
ComboClass     db  'combobox',0

ClassArray     dd  ButtClass,EditClass,StaticClass,ListboxClass,ScrollClass,ComboClass

.data?
hMem           dd  ?
pMem           dd  ?
hMemD          dd  ?
pMemD          dd  ?
hMemID         dd  ?
pMemID         dd  ?
hMap           dd  ?
pMap           dd  ?
hFile          dd  ?
PE             dd  ?
NumOfSections  dw  ? 
NumOfIDs       dd  ?
NumOfMatchIDs  dd  ?
SavStart       dd  ?
ID             dd  ?

szBuff         db  2048 dup(?)

Dialog         STRUCT
   ID          dd ?
   pointsize   dd ?          ; +
   weight      dd ?          ; +
   bItalic     dd ?          ; +
   lpFont      db 64 dup(?)  ; +
   lpMenu      db 32 dup(?)  ; +
   lpName      db 32 dup(?)  ; +
   Class       db 32 dup(?)  ; +
   lpCaption   db 512 dup(?) ; +
   ExStyle     dd ?          ; +
   Style       dd ?          ; +
   Left        dd ?          ; +
   Top         dd ?          ; +
   Wth         dd ?          ; +
   Hgt         dd ?          ; +
Dialog         ENDS
Dlg            Dialog         <?>

Controls       STRUCT
   ID          dd ?
   lpName      db 32 dup(?)  ; +
   Class       db 32 dup(?)  ; +
   lpCaption   db 512 dup(?) ; +
   ExStyle     dd ?          ; +
   Style       dd ?          ; +
   Left        dd ?          ; +
   Top         dd ?          ; +
   Wth         dd ?          ; +
   Hgt         dd ?          ; +
Controls       ENDS
Ctrls          Controls       <?>

lf             LOGFONT        <?>
ofn            OPENFILENAME   <?>

.code

;=======================================
; Extract Resources Dialog
;=======================================
ExtractRsrc PROC  uses ebx esi edi hWnd, hInst, hREdit, hDlg

LOCAL    VirAddr:DWORD, PTRData, TypePE, Diff, BytesO, NumIds1, NumIds2, NumofDlgs, NumofCtrls
LOCAL    OffPosS:DWORD, OffPosID, RsrcID, Cnt, Cnt1, Len, CntID, ResOn, BytesRead
LOCAL    rsrcOn:DWORD, Lnum, SavPos, Hold, CtrlCnt, BIOn, Dlgs, DlgVer, Base, SavClass
LOCAL    szWorkS[64]:BYTE, szBuff4[256]:BYTE

         and     TypePE, 0
         and     NumOfIDs, 0
         and     NumofDlgs, 0
         and     NumofCtrls, 0
         and     NumOfMatchIDs, 0
         mov     szBuff, 0
      INVOKE     SetDlgItemInt, hDlg, 701, NumofDlgs, 0
      INVOKE     SetDlgItemInt, hDlg, 702, NumofCtrls, 0
      INVOKE     UpdateWindow, hDlg

         mov     ofn.lStructSize, sizeof ofn
       MOVmd     ofn.hwndOwner, hREdit
       MOVmd     ofn.hInstance, hInst
         mov     ofn.lpstrFilter, offset szPE
         mov     ofn.lpstrFile, offset szBuff
         mov     ofn.nMaxFile, sizeof szBuff
         mov     ofn.lpstrTitle, offset szTitleO
         mov     ofn.Flags, OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST or OFN_HIDEREADONLY
      INVOKE     GetOpenFileName, addr ofn
         cmp     eax, FALSE           ; Cancel'ed or error occurred
          je     ExtractRsrcDone

      .if pMap
         INVOKE     HeapDestroy, hMemD
         INVOKE     HeapDestroy, hMemID
         INVOKE     UnmapViewOfFile, pMap
         INVOKE     CloseHandle, hMap
            and     pMap, 0
      .endif

      INVOKE     UpdateWindow, hREdit

      INVOKE     CreateFile, addr szBuff,\
                 GENERIC_READ, FILE_SHARE_READ,\
                 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0

      .if eax == -1
         INVOKE     MessageBox, hWnd, addr szAccess, addr AppName, MB_OK
            jmp     ExtractRsrcDone
      .endif

         mov     hFile, eax
      INVOKE     GetFileSize, hFile, 0
         mov     BytesRead, eax

      INVOKE     CreateFileMapping, hFile, NULL, PAGE_READONLY, 0, 0, 0
         cmp     eax, FALSE           ; Error occurred
          je     ExtractRsrcDone
         mov     hMap, eax
      INVOKE     MapViewOfFile, hMap, FILE_MAP_READ, 0, 0, 0
         cmp     eax, FALSE           ; Error occurred
          je     ExtractRsrcDone
         mov     pMap, eax

      INVOKE     CloseHandle, hFile

;---------- [Group ID array] ----------
         mov     BytesO, 2000000 ;64000
      INVOKE     HeapCreate, HEAP_GENERATE_EXCEPTIONS, BytesO, 0
         mov     hMemID, eax
      INVOKE     HeapAlloc, hMemID, HEAP_GENERATE_EXCEPTIONS, BytesO
         mov     pMemID, eax

;---------- [Dialog array] ----------
         mov     BytesO, 2000000 ;164000
      INVOKE     HeapCreate, HEAP_GENERATE_EXCEPTIONS, BytesO, 0
         mov     hMemD, eax
      INVOKE     HeapAlloc, hMemD, HEAP_GENERATE_EXCEPTIONS, BytesO
         mov     pMemD, eax


;_____________________________________________________________________
;---------- [Check if loaded file is a .res file] ----------
         and     ResOn, 0
      INVOKE     lstrlen, addr szBuff
      .if byte ptr szBuff[eax-3] == 'r' || byte ptr szBuff[eax-3] == 'R'
            xor     eax, eax
            xor     ebx, ebx
            mov     Base, 4
            and     OffPosID, 0
            and     RsrcID, 0
            mov     esi, pMap

;---------- [Build the dialog address pointer sturctures] ----------
         .while (ebx < BytesRead)
             MOVmw     ID, word ptr [esi+ebx+10]
;DSPValue hWnd, ID, 1, 'm'
            .if ID == 5
                  mov     ecx, ebx
                  mov     eax, dword ptr [esi+ebx+4]
                  add     ecx, eax                           ; Size of the header
                MOVmw     RsrcID, word ptr [esi+ebx+14]
                  mov     edi, pMemID
                  mov     eax, OffPosID
                MOVmd     dword ptr [edi+eax], ID
                MOVmd     dword ptr [edi+eax+4], RsrcID      ; Resource ID for the dialog
                  mov     dword ptr [edi+eax+8], ecx         ; Actual address in the .res file
                MOVmd     dword ptr [edi+eax+12], 0 ;dword ptr [esi+edx+4] ; Size of image or group
                MOVmd     dword ptr [edi+eax+16], dword ptr [esi+ebx+30] ; Code Page
                  mov     dword ptr [edi+eax+20], 0
                  mov     dword ptr [edi+eax+24], 0
                  mov     dword ptr [edi+eax+28], 0


;---------- [See if a named ID] ----------
               .if word ptr [esi+ebx+12] != 0ffffh
                     mov     RsrcID, 6969
                   MOVmd     dword ptr [edi+eax+4], RsrcID
                     mov     edx, ebx
                     add     edx, 12
                     add     eax, 32
;---------- [Convert Unicode] ----------
                  .while (byte ptr [esi+edx] != 0)
                        mov     cl, byte ptr [esi+edx]        ; Offset to Name Entry Name
                        mov     byte ptr [edi+eax], cl
                        add     edx, 2
                        inc     eax
                  .endw
                     mov     byte ptr [edi+eax], 0
               .endif


                  add     OffPosID, 64 ;32                       ; Length of ID array
                  inc     NumOfMatchIDs
            .endif

               mov     eax, dword ptr [esi+ebx]
               add     eax, dword ptr [esi+ebx+4]
               add     ebx, eax

;---------- [Check if next resource address is on a dword boundry] ----------
               xor     edx, edx
               mov     eax, ebx
               div     Base
            .if edx
                  add     ebx, 1 ;2
            .endif
               xor     edx, edx
               mov     eax, ebx
               div     Base
            .if edx
                  add     ebx, 1 ;2 ;1
            .endif

               xor     edx, edx
               mov     eax, ebx
               div     Base
            .if edx
                  add     ebx, 1 ;2
            .endif
         .endw

         .if !NumOfMatchIDs
               jmp     NoDialogs
         .endif
         INVOKE     lstrcpy, pMemD, addr szCRLF
            inc     ResOn
            jmp     FromRes
      .endif
;_____________________________________________________________________


;---------- [Check for PE type file] ----------
      .if BytesRead < 3ch
            jmp     NoRsrc
      .endif
         mov     ebx, pMap
         mov     ax, word ptr [ebx]
      .if ax == 'ZM'                                         ; IMAGE_DOS_SIGNATURE  -DOS MZ header-
            mov     edx, 3ch
            xor     eax, eax
;            mov     al, byte ptr [ebx+edx]
            mov     ax, word ptr [ebx+edx]
            add     ebx, eax
            mov     eax, dword ptr [ebx]
         .if eax == IMAGE_NT_SIGNATURE                       ; IMAGE_NT_SIGNATURE   -PE header-
               mov     TypePE, 1
         .endif
      .endif
         cmp     TypePE, 0
          je     NoRsrc

         and     rsrcOn, 0
         mov     edi, pMap
      assume edi:ptr IMAGE_DOS_HEADER
         add     edi, [edi].e_lfanew
      assume edi:ptr IMAGE_NT_HEADERS
         mov     ax, [edi].FileHeader.NumberOfSections
         mov     NumOfSections, ax
         add     edi, sizeof IMAGE_NT_HEADERS
         mov     esi, edi
         mov     ax, NumOfSections
       movzx     eax, ax
         mov     edi, eax
      assume esi:ptr IMAGE_SECTION_HEADER
      .while edi > 0
         INVOKE     lstrcpyn, addr szWorkS, addr [esi].Name1, 8
         .if dword ptr szWorkS+1 == 'crsr'                   ; Resource header
               mov     rsrcOn, esi
             MOVmd     VirAddr, [esi].VirtualAddress
             MOVmd     PTRData, [esi].PointerToRawData
               mov     eax, VirAddr
               sub     eax, PTRData
               mov     Diff, eax
            .break
         .endif
            dec     edi
            add     esi, sizeof IMAGE_SECTION_HEADER
      .endw

      .if !rsrcOn
            jmp     NoRsrc
      .endif
         and     Lnum, 0
         and     Dlgs, 0
         and     OffPosS, 0
         and     OffPosID, 0
         and     NumIds2, 0
         mov     esi, pMap
         add     esi, PTRData

;---------- [In Resource Directory (Type)] ----------
      assume esi:ptr IMAGE_RESOURCE_DIRECTORY                ; Resource Directory (Type)
            xor     eax, eax
            mov     ax, [esi].NumberOfIdEntries
            mov     NumIds1, eax                             ; Total num of ID entries
            and     SavPos, 0

         INVOKE     lstrcpy, pMemD, addr szCRLF

      .while (NumIds1)                                       ; In Resource Directory (Type)
            mov     eax, SavPos
            add     eax, 10h
            mov     SavPos, eax
            sub     SavPos, 8

;---------- [Check for Cursor, Icon, Bitmap, or Dialog ID  1-2-3-5] ----------

;         .if dword ptr [esi+eax] > 0h && dword ptr [esi+eax] < 4h ||\
;             dword ptr [esi+eax] == 0ch || dword ptr [esi+eax] == 0eh

         .if dword ptr [esi+eax] == 5
             MOVmd     ID, dword ptr [esi+eax]               ; Save the ID
               add     eax, 4
               mov     ebx, dword ptr [esi+eax]              ; Offset to Resource Directory (Name ID)
               and     ebx, 0000ffffh
               add     ebx, 0eh                              ; Offset to Total num of ID's for group
               xor     ecx, ecx
               mov     cx, word ptr [esi+ebx]
               mov     NumIds2, ecx                          ; Total num of ID's for group
               mov     Dlgs, ecx
;            .if !ecx
;                  mov     cx, word ptr [esi+ebx-2]
;                  mov     NumIds2, ecx                       ; Total num of named ID's for group
;                  mov     Dlgs, ecx
                  add     cx, word ptr [esi+ebx-2]
                  mov     NumIds2, ecx                       ; Total num of named ID's for group
                  mov     Dlgs, ecx
;            .endif
               sub     ebx, 2
;DSPValue hWnd, NumIds2, 1, 'm'

;---------- [In Resource Directory (Name ID)] ----------
            .while (NumIds2)                                 ; In Resource Directory (Name ID)
                  add     ebx, 8
                MOVmd     RsrcID, dword ptr [esi+ebx-4]      ; Save the resource or matching ID
                  mov     byte ptr Dlg.lpName, 0

;---------- [See if Named ID] ----------
               .if byte ptr RsrcID[3] == 80h
                     mov     RsrcID, 6969
                     mov     edx, dword ptr [esi+ebx-4]
                     and     edx, 0000ffffh
                     xor     ecx, ecx
                     mov     cx, word ptr [esi+edx]           ; Offset to Name Entry header
                     mov     Cnt, ecx                         ; Size of Name
                     mov     Cnt1, ecx                        ; Size of Name
                     xor     ecx, ecx
                     add     edx, 2
;---------- [Convert Unicode] ----------
                  .while (Cnt)
                        mov     al, byte ptr [esi+edx]        ; Offset to Name Entry Name
                        mov     byte ptr Dlg.lpName[ecx], al
                        add     edx, 2
                        inc     ecx
                        dec     Cnt
                  .endw
                     mov     byte ptr Dlg.lpName[ebx], 0
               .endif

                  mov     edx, dword ptr [esi+ebx]           ; Offset to Directory (Language)
                  and     edx, 0000ffffh
                  add     edx, 14h
;                  mov     edi, esi
                  mov     ecx, dword ptr [esi+edx]           ; Offset to Directory (Data Entry)
                  mov     edx, ecx
                  mov     ecx, dword ptr [esi+edx]           ; Virtual address of resource
                  sub     ecx, Diff                          ; Actual address of resource in the file

;---------- [Build an array of IDs - ID, actual offset, and size] ---------- 
;DSPValue hWnd, ID, 1, 'm'
                  mov     edi, pMemID
                  mov     eax, OffPosID
                MOVmd     dword ptr [edi+eax], ID
                MOVmd     dword ptr [edi+eax+4], RsrcID      ; Resource or matching ID for detail and group
                  mov     dword ptr [edi+eax+8], ecx         ; Actual address in the resource
                MOVmd     dword ptr [edi+eax+12], dword ptr [esi+edx+4] ; Size of image or group
                MOVmd     dword ptr [edi+eax+16], dword ptr [esi+edx+8] ; Code Page
                  mov     dword ptr [edi+eax+20], 0
                  mov     dword ptr [edi+eax+24], 0
                  mov     dword ptr [edi+eax+28], 0


;---------- [Named ID] ----------
               .if RsrcID == 6969
                     inc     Cnt1
                     add     eax, 32
                     xor     ecx, ecx
                  .while (Cnt1)
                        mov     dl, byte ptr Dlg.lpName[ecx]
                        mov     byte ptr [edi+eax], dl
                        inc     ecx
                        inc     eax
                        dec     Cnt1
                  .endw
               .endif


                  add     OffPosID, 64 ;32                       ; Length of ID array
                  inc     NumOfMatchIDs
                  dec     NumIds2
            .endw
         .endif
            dec     NumIds1
      .endw
      .if !Dlgs
            jmp     NoDialogs
      .endif

FromRes:
;---------- [Copy the resource IDs to the dialog array] ----------
       MOVmd     CntID, NumOfMatchIDs
         and     OffPosID, 0
      INVOKE     LoadCursor, 0, IDC_WAIT
      INVOKE     SetCursor, eax
      .while (CntID)
            mov     esi, pMemID
            mov     ebx, OffPosID
            mov     eax, dword ptr [esi+ebx+4]
            and     eax, 0000ffffh                           ; In case a named ID
            mov     dword ptr [esi+ebx+4], eax
            mov     ecx, pMap
            mov     eax, dword ptr [esi+ebx+8]
            add     ecx, eax

            xor     eax, eax
            mov     ax, word ptr [ecx+2]
            mov     DlgVer, eax                              ; ffffh = DLGTEMPLATEEX

            xor     eax, eax
         .if DlgVer == 0ffffh
               mov     ax, word ptr [ecx+16]
         .else
               mov     ax, word ptr [ecx+8]
         .endif
            mov     CtrlCnt, eax

            mov     Dlg.lpMenu, 0
            mov     Dlg.Class, 0
            mov     Dlg.lpCaption, 0
          MOVmd     Dlg.ID, dword ptr [esi+ebx+4]

         .if Dlg.ID == 6969
              push     ecx
               mov     ecx, pMemID
               add     ecx, OffPosID
               add     ecx, 32
            INVOKE     lstrcpy, addr Dlg.lpName, ecx
               mov     esi, pMemID
               mov     ebx, OffPosID
               pop     ecx
         .endif

         .if DlgVer == 0ffffh
             MOVmd     Dlg.ExStyle, dword ptr [ecx+8]
             MOVmd     Dlg.Style, dword ptr [ecx+12]
             MOVmw     Dlg.Left, word ptr [ecx+18]
             MOVmw     Dlg.Top, word ptr [ecx+20]
             MOVmw     Dlg.Wth, word ptr [ecx+22]
             MOVmw     Dlg.Hgt, word ptr [ecx+24]
               add     ecx, 26
         .else
             MOVmd     Dlg.Style, dword ptr [ecx]
             MOVmd     Dlg.ExStyle, dword ptr [ecx+4]
             MOVmw     Dlg.Left, word ptr [ecx+10]
             MOVmw     Dlg.Top, word ptr [ecx+12]
             MOVmw     Dlg.Wth, word ptr [ecx+14]
             MOVmw     Dlg.Hgt, word ptr [ecx+16]
               add     ecx, 18
         .endif

         .if Dlg.Left > 7fffh
               mov     Dlg.Left, 0
         .endif
         .if Dlg.Top > 7fffh
               mov     Dlg.Top, 0
         .endif

         .if word ptr [ecx] != 0   ; = Menu
            .if word ptr [ecx] == 0ffffh
                  xor     eax, eax
                  mov     ax, word ptr [ecx+2]
                  mov     dword ptr Dlg.lpMenu, eax
                  add     ecx, 4
            .else
                 push     ecx
               INVOKE     WideCharToMultiByte, CP_ACP, 0, ecx, -1, addr Dlg.lpMenu, 31, 0, 0
                  shl     eax, 1
                  pop     ecx
                  add     ecx, eax
            .endif
         .else
               add     ecx, 2
         .endif

         .if word ptr [ecx] != 0   ; = Class
            .if word ptr [ecx] == 0ffffh
                  xor     eax, eax
                  mov     ax, word ptr [ecx+2]
                  mov     dword ptr Dlg.Class, eax
                  add     ecx, 4
            .else
                 push     ecx
               INVOKE     WideCharToMultiByte, CP_ACP, 0, ecx, -1, addr Dlg.Class, 31, 0, 0
                  shl     eax, 1
                  pop     ecx
                  add     ecx, eax
            .endif
         .else
               add     ecx, 2
         .endif

         .if word ptr [ecx] != 0   ; = Caption
              push     ecx
            INVOKE     WideCharToMultiByte, CP_ACP, 0, ecx, -1, addr Dlg.lpCaption, 511, 0, 0
               shl     eax, 1
               pop     ecx
               add     ecx, eax
         .else
               add     ecx, 2
         .endif

         .if (Dlg.Style & DS_SETFONT)
             MOVmw     Dlg.pointsize, word ptr [ecx]
            .if DlgVer == 0ffffh
                MOVmw     Dlg.weight, word ptr [ecx+2]
                MOVmw     Dlg.bItalic, word ptr [ecx+4]
                  add     ecx, 6
            .else
                  add     ecx, 2
            .endif
              push     ecx
            INVOKE     WideCharToMultiByte, CP_ACP, 0, ecx, -1, addr Dlg.lpFont, 63, 0, 0
               shl     eax, 1
               pop     ecx
               add     ecx, eax

               xor     edx, edx
               mov     eax, ecx
               mov     ebx, 4
               div     ebx
            .if edx
                  add     ecx, 2
            .endif
         .endif

           push     ecx

               inc     NumofDlgs
            INVOKE     SetDlgItemInt, hDlg, 701, NumofDlgs, 0
            INVOKE     UpdateWindow, hDlg

         .if Dlg.ID != 6969
            INVOKE     BaseAscii, Dlg.ID, addr szWorkS, 1, 10, 1, 1, 0
            INVOKE     lstrcat, pMemD, addr szWorkS
         .else
            INVOKE     lstrcat, pMemD, addr Dlg.lpName
         .endif
         .if DlgVer == 0ffffh
            INVOKE     lstrcat, pMemD, addr szDlgEX
         .else
            INVOKE     lstrcat, pMemD, addr szDlg
         .endif
         INVOKE     BaseAscii, Dlg.Left, addr szWorkS, 1, 10, 1, 1, 0
         INVOKE     lstrcat, pMemD, addr szWorkS
         INVOKE     lstrcat, pMemD, addr szComma
         INVOKE     BaseAscii, Dlg.Top, addr szWorkS, 1, 10, 1, 1, 0
         INVOKE     lstrcat, pMemD, addr szWorkS
         INVOKE     lstrcat, pMemD, addr szComma
         INVOKE     BaseAscii, Dlg.Wth, addr szWorkS, 1, 10, 1, 1, 0
         INVOKE     lstrcat, pMemD, addr szWorkS
         INVOKE     lstrcat, pMemD, addr szComma
         INVOKE     BaseAscii, Dlg.Hgt, addr szWorkS, 1, 10, 1, 1, 0
         INVOKE     lstrcat, pMemD, addr szWorkS
         INVOKE     lstrcat, pMemD, addr szCRLF
         .if Dlg.lpCaption
            INVOKE     lstrcat, pMemD, addr szCapt
            INVOKE     lstrcat, pMemD, addr szQuote
            INVOKE     lstrcat, pMemD, addr Dlg.lpCaption
            INVOKE     lstrcat, pMemD, addr szQuote
            INVOKE     lstrcat, pMemD, addr szCRLF
         .endif
         .if Dlg.lpFont
            INVOKE     lstrcat, pMemD, addr szFont
            INVOKE     BaseAscii, Dlg.pointsize, addr szWorkS, 1, 10, 1, 1, 0
            INVOKE     lstrcat, pMemD, addr szWorkS
            INVOKE     lstrcat, pMemD, addr szComma
            INVOKE     lstrcat, pMemD, addr szSpace
            INVOKE     lstrcat, pMemD, addr szQuote
            INVOKE     lstrcat, pMemD, addr Dlg.lpFont
            INVOKE     lstrcat, pMemD, addr szQuote
            INVOKE     lstrcat, pMemD, addr szCRLF
         .endif
         INVOKE     lstrcat, pMemD, addr szSty
         INVOKE     lstrcat, pMemD, addr szx
         INVOKE     BaseAscii, Dlg.Style, addr szWorkS, 8, 16, 1, 1, 1  ; ??????
         INVOKE     lstrcat, pMemD, addr szWorkS
         INVOKE     lstrcat, pMemD, addr szCRLF
         INVOKE     lstrcat, pMemD, addr szEXSty
         INVOKE     lstrcat, pMemD, addr szx
         INVOKE     BaseAscii, Dlg.ExStyle, addr szWorkS, 8, 16, 1, 1, 1  ; ??????
         INVOKE     lstrcat, pMemD, addr szWorkS
         INVOKE     lstrcat, pMemD, addr szCRLF
         INVOKE     lstrcat, pMemD, addr szBegin
            pop     ecx

         .while (CtrlCnt)
;---------- [Align on a DWORD boundry] ----------
               xor     edx, edx
               mov     eax, ecx
               mov     ebx, 4
               div     ebx
            .if edx
                  add     ecx, 2
            .endif

               xor     eax, eax
            .if DlgVer == 0ffffh
                  mov     ax, word ptr [ecx+20]
                  mov     Ctrls.ID, eax
                MOVmd     Ctrls.ExStyle, dword ptr [ecx+4]
                MOVmd     Ctrls.Style, dword ptr [ecx+8]
                MOVmw     Ctrls.Left, word ptr [ecx+12]
                MOVmw     Ctrls.Top, word ptr [ecx+14]
                MOVmw     Ctrls.Wth, word ptr [ecx+16]
                MOVmw     Ctrls.Hgt, word ptr [ecx+18]
                  add     ecx, 22
            add     ecx, 2
            .else
                  mov     ax, word ptr [ecx+16]
                  mov     Ctrls.ID, eax
                MOVmd     Ctrls.Style, dword ptr [ecx]
                MOVmd     Ctrls.ExStyle, dword ptr [ecx+4]
                MOVmw     Ctrls.Left, word ptr [ecx+8]
                MOVmw     Ctrls.Top, word ptr [ecx+10]
                MOVmw     Ctrls.Wth, word ptr [ecx+12]
                MOVmw     Ctrls.Hgt, word ptr [ecx+14]
                  add     ecx, 18
            .endif

            .if Ctrls.Left > 7fffh
                  mov     Ctrls.Left, 0
            .endif
            .if Ctrls.Top > 7fffh
                  mov     Ctrls.Top, 0
            .endif

               mov     Ctrls.Class, 0
               and     SavClass, 0
            .if word ptr [ecx] != 0   ; = Class
               .if word ptr [ecx] == 0ffffh
                     xor     eax, eax
                     mov     ax, word ptr [ecx+2]
                     mov     SavClass, eax
                     sub     eax, 80h
                     mov     edx, ClassArray[eax*4]
                    push     ecx
                  INVOKE     lstrcpy, addr Ctrls.Class, edx
                     pop     ecx
                     add     ecx, 4
               .else
                    push     ecx
                  INVOKE     WideCharToMultiByte, CP_ACP, 0, ecx, -1, addr Ctrls.Class, 31, 0, 0
                     shl     eax, 1
                     pop     ecx
                     add     ecx, eax
               .endif
            .else
                  add     ecx, 2
            .endif

               and     BIOn, 0
               mov     Ctrls.lpCaption, 0
            .if word ptr [ecx] != 0   ; = Caption
               .if word ptr [ecx] == 0ffffh
                     mov     BIOn, 1
                     xor     ebx, ebx
                     mov     bx, word ptr [ecx+2]
                  INVOKE     BaseAscii, ebx, addr szWorkS, 1, 10, 1, 1, 0
                    push     ecx
                  INVOKE     lstrcpy, addr Ctrls.lpCaption, addr szWorkS
                     pop     ecx
                     add     ecx, 4
               .else

                    push     ecx
                  INVOKE     WideCharToMultiByte, CP_ACP, 0, ecx, -1, addr Ctrls.lpCaption, 511, 0, 0
                     shl     eax, 1
                     pop     ecx
                     add     ecx, eax
               .endif

            .else
                  add     ecx, 2
            .endif

            .if DlgVer != 0ffffh
;---------- [Offset + 4 if dword boundry and DLGTEMPLATE DUMP!!!] ----------
                  xor     edx, edx
                  mov     eax, ecx
                  mov     ebx, 4
                  div     ebx
               .if !edx
                     add     ecx, 4
               .endif
            .endif

              push     ecx

               inc     NumofCtrls
            INVOKE     SetDlgItemInt, hDlg, 702, NumofCtrls, 0
            INVOKE     UpdateWindow, hDlg

            INVOKE     lstrcat, pMemD, addr szCont
            .if !BIOn                                        ; BIOn = Bitmap, Icon
               INVOKE     lstrcat, pMemD, addr szQuote
            .endif

;;.if byte ptr Ctrls.lpCaption == 0ah
;   INVOKE     lstrlen, addr Ctrls.lpCaption
;      mov     ecx, eax
;      xor     eax, eax
;   .while (ecx)
;      .if byte ptr Ctrls.lpCaption[eax] == 0ah
;            mov     byte ptr Ctrls.lpCaption[eax], '$'
;      .endif
;         inc     eax
;         dec     ecx
;   .endw
;;.endif

            INVOKE     lstrcpy, addr szBuff, addr Ctrls.lpCaption
            INVOKE     lstrlen, addr szBuff
               mov     ecx, eax
               xor     eax, eax
               xor     ebx, ebx
            .while (ecx)
                  mov     dl, byte ptr szBuff[eax]
               .if dl == 0ah
                     mov     byte ptr Ctrls.lpCaption[ebx], '\'
                     mov     byte ptr Ctrls.lpCaption[ebx+1], 'n'
                     inc     ebx
               .elseif dl == '"'
                     mov     byte ptr Ctrls.lpCaption[ebx], '"'
                     mov     byte ptr Ctrls.lpCaption[ebx+1], '"'
                     inc     ebx
               .else
                     mov     byte ptr Ctrls.lpCaption[ebx], dl
               .endif
                  inc     eax
                  inc     ebx
                  dec     ecx
            .endw
               mov     byte ptr Ctrls.lpCaption[ebx], 0


            .if SavClass > 82h && SavClass < 86h
                  mov     byte ptr Ctrls.lpCaption, 0
            .endif

;            .if (Ctrls.Style & SS_ETCHEDHORZ) && (Ctrls.Style & SS_ETCHEDVERT) ||\
;                (Ctrls.Style & SS_BLACKFRAME)

               mov     eax, Ctrls.Style
               mov     ebx, Ctrls.Style
               and     eax, 000000f0h
               and     ebx, 0000000fh

            .if SavClass == 82h
               .if ebx == SS_BLACKFRAME || eax == SS_GRAYFRAME || eax == SS_WHITEFRAME
                  mov     byte ptr Ctrls.lpCaption, 0
               .endif
            .endif

            .if (eax == 10h) && (ebx == 2)
                  mov     byte ptr Ctrls.lpCaption, 0
            .endif


            INVOKE     lstrcat, pMemD, addr Ctrls.lpCaption
            .if !BIOn
               INVOKE     lstrcat, pMemD, addr szQuote
            .endif
            INVOKE     lstrcat, pMemD, addr szComma
            .if Ctrls.ID != 0ffffh
               INVOKE     BaseAscii, Ctrls.ID, addr szWorkS, 1, 10, 1, 1, 0
               INVOKE     lstrcat, pMemD, addr szWorkS
            .else
               INVOKE     lstrcat, pMemD, addr szMinus1
            .endif
            INVOKE     lstrcat, pMemD, addr szComma
            INVOKE     lstrcat, pMemD, addr szQuote
            INVOKE     lstrcat, pMemD, addr Ctrls.Class
            INVOKE     lstrcat, pMemD, addr szQuote
            INVOKE     lstrcat, pMemD, addr szComma
            INVOKE     lstrcat, pMemD, addr szx
            INVOKE     BaseAscii, Ctrls.Style, addr szWorkS, 8, 16, 1, 1, 1  ; ??????
            INVOKE     lstrcat, pMemD, addr szWorkS
            INVOKE     lstrcat, pMemD, addr szComma
               and     Len, 0
               mov     Cnt, 4
            .while (Cnt)
                  mov     ecx, Len
               INVOKE     BaseAscii, Ctrls.Left[ecx*4], addr szWorkS, 1, 10, 1, 1, 0
               INVOKE     lstrcat, pMemD, addr szWorkS
               INVOKE     lstrcat, pMemD, addr szComma
                  inc     Len
                  dec     Cnt
            .endw
            INVOKE     lstrcat, pMemD, addr szx
            INVOKE     BaseAscii, Ctrls.ExStyle, addr szWorkS, 8, 16, 1, 1, 1  ; ??????
            INVOKE     lstrcat, pMemD, addr szWorkS
            INVOKE     lstrcat, pMemD, addr szCRLF
               pop     ecx
.if DlgVer == 0ffffh
               add     ecx, 2
.endif
               dec     CtrlCnt
         .endw
         INVOKE     lstrcat, pMemD, addr szEnd
         INVOKE     lstrcat, pMemD, addr szCRLF

            dec     CntID
            add     OffPosID, 64 ;32
      .endw

      INVOKE     lstrcat, pMemD, addr szNULL
      INVOKE     SendMessage, hREdit, WM_SETTEXT, FALSE, pMemD
;      INVOKE     BaseAscii, NumOfMatchIDs, addr szDlgNum, 2, 10, 1, 0, 0
;      INVOKE     BaseAscii, NumofCtrls, addr szCtrlNum, 2, 10, 1, 0, 0
;      INVOKE     MessageBox, NULL, addr szDlgNum, addr AppName, MB_OK
;         mov     dword ptr szDlgNum, '    '
;         mov     dword ptr szCtrlNum, '    '
         jmp     ExtractRsrcDone

NoDialogs:
      INVOKE     SendMessage, hREdit, WM_SETTEXT, FALSE, addr szNULL
      INVOKE     MessageBox, hWnd, addr szError7, addr AppName, MB_OK
         jmp     ExtractRsrcDone

NoRsrc:
      INVOKE     SendMessage, hREdit, WM_SETTEXT, FALSE, addr szNULL
      INVOKE     MessageBox, hWnd, addr szError8, addr AppName, MB_OK

ExtractRsrcDone:
      INVOKE     LoadCursor, 0, IDC_ARROW
      INVOKE     SetCursor, eax

      .if pMap
         INVOKE     HeapDestroy, hMemD
         INVOKE     HeapDestroy, hMemID
         INVOKE     UnmapViewOfFile, pMap
         INVOKE     CloseHandle, hMap
            and     pMap, 0
      .endif

         mov     eax, FALSE                                  ; Return with FALSE

         ret
ExtractRsrc ENDP

         END
