         title   Toolbar Build

         .586
         .model flat, stdcall
         option casemap:none   ; Case sensitive

            include  \Masm32V1\include\Windows.inc
            include  \Masm32V1\include\user32.inc
            include  \Masm32V1\include\kernel32.inc
            include  \Masm32V1\include\gdi32.inc
            include  \Masm32V1\include\comctl32.inc
            include  \Masm32V1\include\comdlg32.inc
            include  \Masm32V1\include\advapi32.inc

   include  \Masm32V1\include\DSPMACRO.asm

         includelib  \Masm32V1\lib\user32.lib
         includelib  \Masm32V1\lib\kernel32.lib
         includelib  \Masm32V1\lib\gdi32.lib
         includelib  \Masm32V1\lib\comctl32.lib
         includelib  \Masm32V1\lib\comdlg32.lib
         includelib  \Masm32V1\lib\advapi32.lib

;======================================================
; PROTO, MACRO, and Data section
;======================================================
WinMain         PROTO  :DWORD, :DWORD, :DWORD, :DWORD
GetData         PROTO  :DWORD, :DWORD, :DWORD
ToolBarDlg      PROTO  :DWORD, :DWORD, :DWORD, :DWORD
RichEditProc    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
BuildR          PROTO  :DWORD

TBSep   MACRO hTool
          mov     tbb.iBitmap, 0
          mov     tbb.idCommand, 0
          mov     tbb.fsState, TBSTATE_ENABLED
          mov     tbb.fsStyle, TBSTYLE_SEP
       INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
         ENDM

TBButt  MACRO hTool, BmpID, CmdID, Text
          mov     tbb.iBitmap, BmpID    ; Button image number
          mov     tbb.idCommand, CmdID  ; Command ID number
          mov     tbb.fsState, TBSTATE_ENABLED
          mov     tbb.fsStyle, TBSTYLE_BUTTON
          mov     tbb.dwData, 0
          mov     tbb.iString, Text
       INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
         ENDM

MOVmd    MACRO Var1, Var2
         push     Var2
          pop     Var1
         ENDM

.const
IDM_NEW        equ 1001
IDM_OPEN       equ 1002
IDM_SAVE       equ 1003
IDM_CUT        equ 1004
IDM_COPY       equ 1005
IDM_PASTE      equ 1006
IDM_DELETE     equ 1007
IDM_FIND       equ 1008
IDM_FINDNEXT   equ 1009
IDM_FINDPREV   equ 1010
IDM_REPLACE    equ 1011
IDM_EXIT       equ 1012
IDM_SELALL     equ 3001
IDM_TOOLBAR    equ 8001
IDM_MENU       equ 8002
IDM_TAB        equ 8003
IDM_DIALOG     equ 8040

IDD_DLG01      equ 7000
IDC_STATIC01   equ 7001
IDC_STATIC02   equ 7002
IDC_STATIC03   equ 7003
IDC_STATIC04   equ 7004
IDC_STATIC05   equ 7005
IDC_STATIC06   equ 7006
IDC_STATIC07   equ 7007
IDC_GRP01      equ 7008
IDC_GRP02      equ 7009

IDC_LISTBOX01  equ 2001
IDC_LISTBOX02  equ 2002
IDC_RITIMID    equ 2003
IDC_RNAME      equ 2004
IDC_BINSERT    equ 2005
IDC_BADD       equ 2006
IDC_BREMOVE    equ 2007
IDC_BMOVEU     equ 2008
IDC_BMOVED     equ 2009
IDC_BSTYLESU   equ 2010
IDC_BSTYLESR   equ 2011
IDC_BRESTORE   equ 2012
IDC_BBUILD     equ 2013
IDC_BCHANGEW   equ 2014
IDC_CHK01      equ 2015
IDC_CHK02      equ 2016
IDC_CHK03      equ 2017
IDC_CHK04      equ 2018
IDC_CHK05      equ 2019
IDC_CHK06      equ 2020
IDC_CHK07      equ 2021
IDC_CHK08      equ 2022
IDC_CHK09      equ 2023
IDC_CHK10      equ 2024
IDC_ETOOLTEXT  equ 2025
IDC_ETOOLTIP   equ 2026
IDC_EIDNAME    equ 2027
IDC_ESTARTID   equ 2028
IDC_ECHANGEW   equ 2029

.data
RichEdit       db  'RichEdit20A',0
RichEdDLL      db  'RICHED20.DLL',0
FontNameCN     db  'Courier New',0
FontNameAR     db  'Arial',0 ;'MS Sans Serif',0
FontNameMS     db  'MS Sans Serif',0
PopupMenu      db  'PopupMenu',0
FontHeight     dd  -12
FontW          dd  400
StatClass      db  'msctls_statusbar32',0
szPart1        db  'Part 1',0
szPart3        db  'Part 3',0
ToolClass      db  'ToolbarWindow32',0
ClassName      db  'Toolbar Control',0
AppName        db  'Toolbar Control',0
MenuName       db  'MainMenu',0

szMenu1        db  'Hide Dialog',0
szMenu2        db  'Show Dialog',0
szSep          db  'Seperator',0
szCRLF         db  0dh,0ah,0
szNull         db  0
szSlashB       db  '\',0
szAll          db  '*.*',0
szClear        db  '          ',0
szSpace        db  ' ',0
szQuote        db  '"',0
szQuoteS       db  "'",0
szZero         db  '0',0
szComma        db  ',',0
szSZ           db  'sz',0
szDB           db  'db  ',0
szBmp          db  '.bmp',0
szIDM          db  'IDM_',0
szNN           dd  'NN',0
szWW           dd  'WW',0
szOffset       db  ' offset ',0

szTemp         db  'Temp.txt',0

szEqu          db  'equ ',0
szTBSep        db  '          TBSep     hWndTool',0
szTBButt       db  '         TBButt     hWndTool, ',0
szResr1        db  '    BITMAP  DISCARDABLE  "',0
szResr2        db  'Res',0
szStyle        db  '                    WS_CHILD or WS_VISIBLE or WS_BORDER or TBSTYLE_TOOLTIPS\',0dh,0ah,0
szFill         db  '                   ',0
szFlat         db  ' or TBSTYLE_FLAT',0
szList         db  ' or TBSTYLE_LIST',0
szNoP          db  ' or CCS_NOPARENTALIGN',0
szNoD          db  ' or CCS_NODIVIDER',0
szAdj          db  ' or CCS_ADJUSTABLE',0
szNoR          db  ' or CCS_NORESIZE',0
szBot          db  ' or CCS_BOTTOM',0


szToolbarRes   db  ';***** [Place in the Resource file (.rc)] *****',0dh,0ah,0

szDefine       db  '#define   ',0

szToolbarTip   db  'STRINGTABLE DISCARDABLE',0dh,0ah
               db  'BEGIN',0dh,0ah
               db  '/* toolbar tips */',0dh,0ah,0

szEnd          db  'END',0dh,0ah
               db  ';***** [End of resource definitions] *****',0dh,0ah,0

szToolbarMac   db  ';***** [Place in the Application or Include file] *****',0dh,0ah,0dh,0ah
               db  'ChgBmpColor      PROTO :DWORD',0dh,0ah,0dh,0ah
               db  ';---------- [Toolbar structure macros] ----------',0dh,0ah
               db  'TBSep    MACRO hTool',0dh,0ah
               db  '           mov     tbb.iBitmap, 0',0dh,0ah
               db  '           mov     tbb.idCommand, 0',0dh,0ah
               db  '           mov     tbb.fsState, TBSTATE_ENABLED',0dh,0ah
               db  '           mov     tbb.fsStyle, TBSTYLE_SEP',0dh,0ah
               db  '        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb',0dh,0ah
               db  '          ENDM',0dh,0ah
               db  0dh,0ah
               db  'TBButt   MACRO hTool, BmpID, CmdID, Text',0dh,0ah
               db  '           mov     tbb.iBitmap, BmpID    ; Button image number',0dh,0ah
               db  '           mov     tbb.idCommand, CmdID  ; Command ID number',0dh,0ah
               db  '           mov     tbb.fsState, TBSTATE_ENABLED',0dh,0ah
               db  '           mov     tbb.fsStyle, TBSTYLE_BUTTON',0dh,0ah
               db  '           mov     tbb.dwData, 0',0dh,0ah
               db  '           mov     tbb.iString, Text',0dh,0ah
               db  '        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb',0dh,0ah
               db  '          ENDM',0dh,0ah,0dh,0ah
               db  '.const',0dh,0ah,0

szToolbarDat1  db  ';***** [Place in the Application file (.asm)] *****',0dh,0ah,0dh,0ah
               db  '.data',0dh,0ah
               db  "ToolClass      db  'ToolbarWindow32',0",0dh,0ah,0dh,0ah,0

szToolbarDat2  db  '.data?',0dh,0ah
               db  'hWndTool       dd  ?',0dh,0ah
               db  'hImageList     dd  ?',0dh,0ah,0dh,0ah,0

szWinProc      db  ';======================================================',0dh,0ah
               db  '; WinProc procedure',0dh,0ah
               db  ';======================================================',0dh,0ah
               db  'WndProc proc  uses ebx  hwnd:DWORD, wMsg, wParam, lParam',0dh,0ah,0dh,0ah,0

szToolbarLoc   db  'LOCAL    tbb:TBBUTTON',0dh,0ah
               db  'LOCAL    tbab:TBADDBITMAP',0dh,0ah
               db  'LOCAL    bSize:DWORD, hTbBmp, ID, Cnt',0dh,0ah,0dh,0ah,0

szToolbarWnd1  db  '      .if wMsg == WM_CREATE',0dh,0ah,0dh,0ah

               db  ';---------- [Create the Toolbar Window] ----------',0dh,0ah
               db  '         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,\',0dh,0ah,0

szToolbarWnd2  db  '                    0, -2, 1200, 26, hwnd, 0, hInst, 0',0dh,0ah
               db  '            mov     hWndTool, eax',0dh,0ah,0dh,0ah,0

szToolbarCre   db  ';---------- [Create the ImageList] ----------',0dh,0ah
               db  '         INVOKE     ImageList_Create, 16, 16, ILC_COLOR32, NN, 0',0dh,0ah
               db  '            mov     hImageList, eax',0dh,0ah,0dh,0ah

               db  ';---------- [Load The Bitmaps] ----------',0dh,0ah
               db  '            mov     ID, 701           ; Bitmap ID',0dh,0ah
               db  '            mov     Cnt, NN',0dh,0ah
               db  '         .while (Cnt)',0dh,0ah
               db  '            INVOKE     LoadImage, hInst, ID, IMAGE_BITMAP, 16, 16, LR_DEFAULTCOLOR',0dh,0ah
               db  '            INVOKE     ChgBmpColor, eax',0dh,0ah
               db  '               mov     hTbBmp, eax',0dh,0ah
               db  '            INVOKE     ImageList_Add, hImageList, hTbBmp, NULL',0dh,0ah
               db  '            INVOKE     DeleteObject, hTbBmp',0dh,0ah
               db  '               inc     ID',0dh,0ah
               db  '               dec     Cnt',0dh,0ah
               db  '         .endw',0dh,0ah
               db  0dh,0ah
               db  '         INVOKE     SendMessage, hWndTool, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0',0dh,0ah
               db  '         INVOKE     SendMessage, hWndTool, TB_SETIMAGELIST, 0, hImageList',0dh,0ah,0dh,0ah

               db  ';---------- [Size the Bitmap and Button] ----------',0dh,0ah
               db  '            mov     ecx, 16  ; loword = bitmap Width',0dh,0ah
               db  '            mov     eax, 16  ; hiword = bitmap Height',0dh,0ah
               db  '            shl     eax, 16',0dh,0ah
               db  '            mov     ax, cx',0dh,0ah
               db  '            mov     bSize, eax',0dh,0ah
               db  '         INVOKE     SendMessage, hWndTool, TB_SETBITMAPSIZE, 0, bSize',0dh,0ah
               db  '            mov     ecx, WW  ; loword = button Width',0dh,0ah
               db  '            mov     word ptr bSize, cx',0dh,0ah
               db  '         INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, bSize',0dh,0ah,0dh,0ah

               db  ';---------- [Create the Toolbar structures] ----------',0dh,0ah,0

szToolSizTip   db  ';---------- [Move and Size the Control(s)] ----------',0dh,0ah
               db  '      .elseif wMsg == WM_SIZE',0dh,0ah,0dh,0ah

               db  ';---------- [Size the Toolbar Control] ----------',0dh,0ah
               db  '         INVOKE     SendMessage, hWndTool, TB_AUTOSIZE, 0, 0',0dh,0ah,0dh,0ah

               db  ';---------- [Get Tooltips] ----------',0dh,0ah
               db  '      .elseif wMsg == WM_NOTIFY',0dh,0ah
               db  '            mov     ecx, lParam          ; Get pointer to NMHDR',0dh,0ah
               db  '            mov     eax, (NMHDR ptr [ecx]).code',0dh,0ah
               db  '         .if eax == TTN_NEEDTEXT',0dh,0ah
               db  '               mov     eax, (NMHDR ptr [ecx]).idFrom ; Resource id',0dh,0ah
               db  '               mov     ecx, eax',0dh,0ah
               db  '            INVOKE     LoadString, hInst, ecx, addr szBuff, lengthof szBuff',0dh,0ah
               db  '               mov     ecx, lParam                   ; Get the buffer addr',0dh,0ah
               db  '               lea     eax, szBuff',0dh,0ah
               db  '               mov     (TOOLTIPTEXT ptr [ecx]).lpszText, eax',0dh,0ah
               db  '               mov     eax, FALSE',0dh,0ah
               db  '               ret',0dh,0ah
               db  '         .endif',0dh,0ah,0dh,0ah,0

szToolbarDes   db  ';---------- [Destroy the ImageList] ----------',0dh,0ah
               db  '      .elseif wMsg == WM_DESTROY',0dh,0ah
               db  '         INVOKE     ImageList_Destroy, hImageList',0dh,0ah,0dh,0ah,0

szChgBmpColor  db  ';===================================================',0dh,0ah
               db  '; ChgBmpColor procedure',0dh,0ah
               db  ';===================================================',0dh,0ah
               db  'ChgBmpColor PROC hBitmap:DWORD',0dh,0ah
               db  'LOCAL    mDC:DWORD, hBrush, hOldBmp, Fill, hOldBrush',0dh,0ah

               db  '      INVOKE     CreateCompatibleDC, NULL',0dh,0ah
               db  '         mov     mDC, eax',0dh,0ah
               db  '      INVOKE     SelectObject, mDC, hBitmap',0dh,0ah
               db  '         mov     hOldBmp, eax',0dh,0ah
               db  '      INVOKE     GetSysColor, COLOR_BTNFACE',0dh,0ah
               db  '      INVOKE     CreateSolidBrush, eax',0dh,0ah
               db  '         mov     hBrush, eax',0dh,0ah
               db  '      INVOKE     SelectObject, mDC, hBrush',0dh,0ah
               db  '         mov     hOldBrush, eax',0dh,0ah
               db  '         mov     Fill, 00c0c0c0h',0dh,0ah
               db  '      INVOKE     ExtFloodFill, mDC, 0, 0, Fill, FLOODFILLSURFACE',0dh,0ah
               db  '      INVOKE     ExtFloodFill, mDC, 0, 15, Fill, FLOODFILLSURFACE',0dh,0ah
               db  '      INVOKE     ExtFloodFill, mDC, 15, 0, Fill, FLOODFILLSURFACE',0dh,0ah
               db  '      INVOKE     ExtFloodFill, mDC, 15, 15, Fill, FLOODFILLSURFACE',0dh,0ah
               db  '      INVOKE     SelectObject, mDC, hOldBrush',0dh,0ah
               db  '      INVOKE     DeleteObject, hBrush',0dh,0ah
               db  '      INVOKE     SelectObject, mDC, hBitmap',0dh,0ah
               db  '        push     eax',0dh,0ah
               db  '      INVOKE     DeleteDC, mDC',0dh,0ah
               db  '         pop     eax',0dh,0ah

               db  '         ret',0dh,0ah
               db  'ChgBmpColor ENDP',0dh,0ah,0

szError1       db  'The RICHED20.DLL was not found!',0
szError2       db  'The file has been modified.',0Dh,0Ah
               db  'Do you wish to save it?',0
szOpenTitle    db  'Open File',0
szSaveTitle    db  'Save File As',0
szFilter       db  'All Files',0,'*.*',0,0
OA             dd  0
w5             dd  0

szFR           db  'Find And Replace',0
FindEnd        db  'There Are No More Matches.'
               db  0Dh,0Ah
               db  'Would You Like To Restart From The'
TopBot         db  ' Top? '
               db  0
Top            db  ' Top? '
Bot            db  ' Bot? '
ToolSet        dd  1,2,3,5,6,7,8,11,12,13,14,16

Text01         db  'New', 0
Text02         db  'Open', 0
Text03         db  'Save', 0
Text04         db  'Cut', 0
Text05         db  'Copy', 0
Text06         db  'Paste', 0
Text07         db  'Delete', 0
Text08         db  'Find', 0
Text09         db  'FindN', 0
Text10         db  'FindP', 0
Text11         db  'Rep', 0
Text12         db  'Exit', 0
szText         dd  Text01,Text02,Text03,Text04,Text05,Text06,
                   Text07,Text08,Text09,Text10,Text11,Text12

Tip01          db  'New', 0
Tip02          db  'Open', 0
Tip03          db  'Save', 0
Tip04          db  'Cut', 0
Tip05          db  'Copy', 0
Tip06          db  'Paste', 0
Tip07          db  'Delete', 0
Tip08          db  'Find', 0
Tip09          db  'Find next match', 0
Tip10          db  'Find previous match', 0
Tip11          db  'Replace', 0
Tip12          db  'Exit this edit program', 0
szTip          dd  Tip01,Tip02,Tip03,Tip04,Tip05,Tip06,
                   Tip07,Tip08,Tip09,Tip10,Tip11,Tip12
fmat1          db  '%01u',0

.data?
hInst          dd  ?
CommandLine    dd  ?
MainExit       dd  ?
hWnd           dd  ?
hREdDll        dd  ?
hREdit         dd  ?
hMenu          dd  ?
hSMenu         dd  ?
hSMenu3        dd  ?
lpRichEdit     dd  ?
hFont          dd  ?
hFontL         dd  ?
hFontD         dd  ?
FontName       db  64  dup(?)
hWndStat       dd  ?
sbParts        dd  4   dup(?)
hWndTool       dd  ?
hToolStyle     dd  ?
hImageList     dd  ?
hImageListM    dd  ?
hToolbarDlg    dd  ?

hDefHeap       dd  ?
ToolArray      dd  ?
ToolArrayM     dd  ?
TextArray      dd  ?
TipArray       dd  ?
hResr          dd  ?
hToolTip       dd  ?
hDefines       dd  ?
hText          dd  ?
hEquate        dd  ?
hToolStr       dd  ?
hOutput        dd  ?

ArrayCnt       dd  ?
StrAddr        dd  ?
StrSize        dd  ?

hListbox1      dd  ?
hListbox2      dd  ?
hRad01         dd  ?
hRad02         dd  ?
hButt01        dd  ?
hButt02        dd  ?
hButt03        dd  ?
hButt04        dd  ?
hButt05        dd  ?
hButt06        dd  ?
hButt07        dd  ?
hButt08        dd  ?
hButt09        dd  ?
hButt10        dd  ?
hChk01         dd  ?
hChk02         dd  ?
hChk03         dd  ?
hChk04         dd  ?
hChk05         dd  ?
hChk06         dd  ?
hChk07         dd  ?
hChk08         dd  ?
hChk09         dd  ?
hChk10         dd  ?
hEdit01        dd  ?
hEdit02        dd  ?
hEdit03        dd  ?
hEdit04        dd  ?
hEdit05        dd  ?

hStat01        dd  ?

hBmp           dd  ?
bSize          dd  ?
hData          dd  ?
BmpID          dd  ?
CmdID          dd  ?
ButtID         dd  ?
ImageID        dd  ?
StartID        dd  ?

BmpCnt         dd  ?
BmpArray       dd  64  dup(?)
BmpCntM        dd  ?
BmpArrayM      dd  64  dup(?)

PathName       db  256 dup(?)
WorkBuff       db  256 dup(?)
szRoot         db  256 dup(?)
FileName       db  64  dup(?)
szNameA        db  32  dup(?)
szTextA        db  32  dup(?)
szTipA         db  64  dup(?)

CustClrs       dd  16  dup(?)

szFind         db  100 dup(?)
szRep          db  100 dup(?)
FRFlags        dd  ?
Prev           dd  ?
hFRDlg         dd  ?

SelList1       dd  ?
SelList2       dd  ?
TBTop          dd  ?
TBHgt          dd  ?
Redo           dd  ?
NoImage        dd  ?
Chk10On        dd  ?
AddOn          dd  ?
EditOn         dd  ?
SavSize        dd  ?

Test4          dd  ?


ToolStructure  STRUCT
   ID          dd  ?
   ImageID     dd  ?        ; +4
   hBitmap     dd  ?        ; +8
   lpName      db 32 dup(?) ; +12
   lpText      db 32 dup(?) ; +44
   lpTip       db 64 dup(?) ; +76
ToolStructure  ENDS
ts             ToolStructure       <>

tsImageID      dd  ?
tshBitmap      dd  ?
tslpName       dd  ?
tslpText       dd  ?
tslpTip        dd  ?

;---------- [Structures] ----------
ft             FINDTEXTEX     <>
charF2         CHARFORMAT2    <>
dis            DRAWITEMSTRUCT <>
tbi            TBBUTTONINFO   <>
mii            MENUITEMINFO   <>

.code

;======================================================
; Program initialization section
;======================================================
start:
      INVOKE     GetModuleHandle, NULL
         mov     hInst, eax
      INVOKE     GetCommandLine
         mov     CommandLine, eax

        call     InitCommonControls
      INVOKE     LoadLibrary, addr RichEdDLL ; Load the Riched20.dll
         mov     hREdDll, eax
      .if !eax
         INVOKE     MessageBox, NULL, addr szError1, addr AppName, MB_OK or MB_ICONERROR
            jmp     NoGo
      .endif

      INVOKE     GetProcessHeap
         mov     hDefHeap, eax

      INVOKE     WinMain, hInst ,NULL, CommandLine, SW_SHOWDEFAULT
         mov     MainExit, eax
      INVOKE     FreeLibrary, hREdDll

NoGo:
      INVOKE     ExitProcess, MainExit

;======================================================
; WinMain procedure
;======================================================
WinMain proc  uses ebx  hinst:DWORD, hPrevInst, CmdLine, CmdShow
LOCAL    wc:WNDCLASSEX
LOCAL    msg:MSG

         mov     wc.cbSize, sizeof WNDCLASSEX
         mov     wc.style, CS_HREDRAW or CS_VREDRAW
         mov     wc.lpfnWndProc, offset WndProc
         mov     wc.cbClsExtra, NULL
         mov     wc.cbWndExtra, NULL
        push     hInst
         pop     wc.hInstance
         mov     wc.hbrBackground, COLOR_BTNFACE+1
         mov     wc.lpszMenuName, offset MenuName
         mov     wc.lpszClassName, offset ClassName
      INVOKE     LoadIcon, NULL, IDI_APPLICATION
         mov     wc.hIcon, eax
         mov     wc.hIconSm, eax
      INVOKE     LoadCursor, NULL, IDC_ARROW
         mov     wc.hCursor, eax
      INVOKE     RegisterClassEx, addr wc

;---------- [Center the window] ----------
      INVOKE     GetSystemMetrics, SM_CXSCREEN
         sub     eax, 480
         shr     eax, 1
        push     eax
      INVOKE     GetSystemMetrics, SM_CYSCREEN
         sub     eax, 402
         shr     eax, 1
         pop     ebx

;---------- [Create the Main Window] ----------
      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr ClassName,\
                 addr AppName, WS_OVERLAPPEDWINDOW,\
                 ebx, eax, 480, 402, NULL, NULL, hInst, NULL ;450
         mov     hWnd, eax

      INVOKE     ShowWindow, hWnd, SW_SHOWNORMAL
      INVOKE     UpdateWindow, hWnd

      INVOKE     GetMenu, hWnd              ; Get handle to main menu
         mov     hMenu, eax

;---------- [Message loop] ----------
      .while TRUE
         INVOKE     GetMessage, addr msg, NULL, 0, 0
            .break .if (!eax)
         INVOKE     IsDialogMessage, hToolbarDlg, addr msg
            cmp     eax, 0
            jne     Pass
         INVOKE     TranslateMessage, addr msg
         INVOKE     DispatchMessage, addr msg

Pass:
      .endw
         mov     eax, msg.wParam
         ret
WinMain endp

;======================================================
; WinProc procedure
;======================================================
WndProc proc  uses ebx  hwnd:DWORD, wmsg, wparam, lparam
LOCAL    rect:RECT
LOCAL    lf:LOGFONT
LOCAL    charF:CHARFORMAT2
LOCAL    tbb:TBBUTTON
LOCAL    tbab:TBADDBITMAP
LOCAL    hTbBmp:DWORD, ID, Cnt, Incr
LOCAL    szBuff[64]:BYTE
;---------- [Create the Control(s) and one time stuff] ----------
      .if wmsg == WM_CREATE

;---------- [Create the status bar window] ----------
         INVOKE     CreateWindowEx, 0, addr StatClass, 0,\
                    WS_CHILD or WS_BORDER or WS_VISIBLE or SBS_SIZEGRIP,\
                    0, 0, 0, 0, hwnd, 0, hInst, 0  
         .if !eax
;Do message
               jmp     Ret0
         .endif
            mov     hWndStat, eax

;---------- [Create the Toolbar Window] ----------
         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                    WS_CHILD or WS_VISIBLE or WS_BORDER or TBSTYLE_TOOLTIPS or TBSTYLE_FLAT or\
                    CCS_NOPARENTALIGN or CCS_NORESIZE or CCS_ADJUSTABLE,\
                    0, -2, 1200, 26, hwnd, 0, hInst, 0
         .if !eax
;Do message
               jmp     Ret0
         .endif
            mov     hWndTool, eax

            mov     TBTop, -2
            mov     TBHgt, 26
         INVOKE     GetWindowLong, hWndTool, GWL_STYLE
            mov     hToolStyle, eax

;---------- [Create the ImageList] ----------
         INVOKE     ImageList_Create, 16, 16, ILC_COLOR32, 12, 64
            mov     hImageList, eax

;---------- [Load The Bitmaps] ----------
            mov     ID, 701           ; Bitmap ID start address
            mov     Cnt, 12           ; Number of bitmaps
         .while (Cnt)
            INVOKE     LoadImage, hInst, ID, IMAGE_BITMAP, 16, 16, LR_DEFAULTCOLOR
               mov     hTbBmp, eax
            INVOKE     ImageList_Add, hImageList, hTbBmp, NULL
            INVOKE     DeleteObject, hTbBmp
               inc     ID
               dec     Cnt
         .endw

         INVOKE     SendMessage, hWndTool, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
         INVOKE     SendMessage, hWndTool, TB_SETIMAGELIST, 0, hImageList

;---------- [Size the Bitmap and Button] ----------
            mov     ecx, 16  ; loword = bitmap Width
            mov     eax, 16  ; hiword = bitmap Height
            shl     eax, 16
            mov     ax, cx
            mov     bSize, eax
         INVOKE     SendMessage, hWndTool, TB_SETBITMAPSIZE, 0, bSize
;            mov     ecx, 23  ; loword = button Width
;            mov     word ptr bSize, cx
         INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, bSize

;---------- [Create the Toolbar structures] ----------
         TBButt     hWndTool, 0, 1001, 0
         TBButt     hWndTool, 1, 1002, 0
         TBButt     hWndTool, 2, 1003, 0
          TBSep     hWndTool
         TBButt     hWndTool, 3, 1004, 0
         TBButt     hWndTool, 4, 1005, 0
         TBButt     hWndTool, 5, 1006, 0
         TBButt     hWndTool, 6, 1007, 0
          TBSep     hWndTool
         TBButt     hWndTool, 7, 1008, 0
         TBButt     hWndTool, 8, 1009, 0
         TBButt     hWndTool, 9, 1010, 0
         TBButt     hWndTool, 10,1011, 0
          TBSep     hWndTool
         TBButt     hWndTool, 11,1012, 0

;---------- [Create the Edit Window] ----------
         INVOKE     CreateWindowEx, NULL, addr RichEdit, NULL,\
                    WS_CHILD or WS_VISIBLE or WS_BORDER or ES_MULTILINE or\
                    ES_NOHIDESEL or ES_SAVESEL or ES_SELECTIONBAR or\
                    WS_HSCROLL or ES_AUTOHSCROLL or\
                    WS_VSCROLL or ES_AUTOVSCROLL,\
                    0, 0, 0, 0, hwnd, 4444, hInst, NULL
         .if !eax
;Do message
               jmp     Ret0
         .endif
            mov     hREdit, eax

         INVOKE     SendMessage, hREdit, EM_EXLIMITTEXT, 0, 4000000
         INVOKE     SetFocus, hREdit

;---------- [Control window subclassed] ----------
         INVOKE     SetWindowLong, hREdit, GWL_WNDPROC, RichEditProc
            mov     lpRichEdit, eax

         INVOKE     LoadMenu, hInst, addr PopupMenu   
         INVOKE     GetSubMenu, eax, 0
            mov     hSMenu, eax

;---------- [Get the character format] ----------
            mov     charF2.cbSize, sizeof charF2
         INVOKE     SendMessage, hREdit, EM_GETCHARFORMAT, TRUE, addr charF2
            mov     eax, FontW
            mov     charF2.wWeight, ax   
         INVOKE     lstrcpy, addr FontName, addr FontNameCN

         INVOKE     RtlZeroMemory, addr lf, sizeof lf
         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontName
           push     FontHeight
            pop     lf.lfHeight
            xor     eax, eax
            mov     ax, charF2.wWeight
            mov     lf.lfWeight, eax
            mov     al, charF2.bCharSet
            mov     lf.lfCharSet, al
            mov     al, charF2.bPitchAndFamily
            mov     lf.lfPitchAndFamily, al
         INVOKE     CreateFontIndirect, addr lf
            mov     hFont, eax

            mov     lf.lfHeight, -10
            mov     lf.lfWeight, 400
         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontNameAR
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontL, eax

            mov     lf.lfHeight, -8
            mov     lf.lfWeight, 400
         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontNameMS
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontD, eax   ; Dialog font

         INVOKE     SendMessage, hREdit, WM_SETFONT, hFont, TRUE

;---------- [Allocate memory from the default heap] ----------
         INVOKE     HeapAlloc, hDefHeap, 0, 15000
            mov     ToolArray, eax
         INVOKE     HeapAlloc, hDefHeap, 0, 15000
            mov     ToolArrayM, eax
         INVOKE     HeapAlloc, hDefHeap, 0, 4096
            mov     TextArray, eax
         INVOKE     HeapAlloc, hDefHeap, 0, 6400
            mov     TipArray, eax
         INVOKE     HeapAlloc, hDefHeap, 0, 2024
            mov     hResr, eax
         INVOKE     HeapAlloc, hDefHeap, 0, 2024
            mov     hToolStr, eax
         INVOKE     HeapAlloc, hDefHeap, 0, 2024
            mov     hToolTip, eax
         INVOKE     HeapAlloc, hDefHeap, 0, 2024
            mov     hDefines, eax
         INVOKE     HeapAlloc, hDefHeap, 0, 2024
            mov     hText, eax
         INVOKE     HeapAlloc, hDefHeap, 0, 2024
            mov     hEquate, eax
         INVOKE     HeapAlloc, hDefHeap, 0, 10000
            mov     hOutput, eax

            mov     mii.cbSize, sizeof mii
            mov     mii.fMask, MIIM_DATA or MIIM_ID or MIIM_STATE or\
                               MIIM_SUBMENU or MIIM_TYPE or MIIM_CHECKMARKS

            mov     tbi.cbSize, sizeof tbi
            lea     eax, ts.ID
            lea     ecx, ts.ImageID
            sub     ecx, eax
            mov     tsImageID, ecx
            lea     ecx, ts.hBitmap
            sub     ecx, eax
            mov     tshBitmap, ecx
            lea     ecx, ts.lpName
            sub     ecx, eax
            mov     tslpName, ecx
            lea     ecx, ts.lpText
            sub     ecx, eax
            mov     tslpText, ecx
            lea     ecx, ts.lpTip
            sub     ecx, eax
            mov     tslpTip, ecx

;---------- [Move and Size the Control(s)] ----------
      .elseif wmsg == WM_SIZE

;---------- [Size the Statusbar Control] ----------
            mov     eax, lparam       ; Get width
            and     eax, 0ffffh       ; Lowword
            shr     eax, 2            ; /4
            mov     ecx, eax          ; Save factor
            mov     sbParts, eax      ; Make part 1 1/4 the width
            add     eax, ecx
            mov     [sbParts+4], eax  ; and also part2, .. etc
            add     eax, ecx
            mov     [sbParts+8], eax
            mov     [sbParts+12], -1  ; The last part extends to the end
         INVOKE     SendMessage, hWndStat, SB_SETPARTS, 4, addr sbParts
         INVOKE     MoveWindow, hWndStat, 0, 0, 0, 0, TRUE
         INVOKE     SendMessage, hWndStat, SB_SETTEXT, 0, addr szPart1
         INVOKE     SendMessage, hWndStat, SB_SETTEXT, 2, addr szPart3

;---------- [Size the Toolbar Control] ----------
         INVOKE     SendMessage, hWndTool, TB_AUTOSIZE, 0, 0

;---------- [Size the Edit Control] ----------
            xor     eax, eax             ; Zero out toolbar height
         .if hWndTool
            INVOKE     GetWindowRect, hWndTool, addr rect ; Rectangle of toolbar
               mov     eax, rect.bottom
               sub     eax, rect.top
         .endif
           push     eax                  ; Save height of toolbar

            xor     eax, eax             ; Zero out statusbar height
         .if hWndStat
            INVOKE     GetWindowRect, hWndStat, addr rect ; Rectangle of statusbar
               mov     eax, rect.bottom
               sub     eax, rect.top     ; eax = height of statusbar
         .endif

            pop     edx                  ; edx = height of toolbar
.if !TBHgt
      and     edx, 0
.else
      mov     edx, 26
.endif
            mov     ebx, lparam          ; Width of new client area
            and     ebx, 0ffffh          ; ebx = width
            mov     ecx, lparam
            shr     ecx, 16              ; Height of new client area
            sub     ecx, eax             ; Edit window - height of statusbar
            sub     ecx, edx             ; Edit window - height of toolbar
         .if edx                         ; If toolbar
               sub     edx, 2            ; For border
               add     ecx, 2            ; For border
         .endif
         .if eax                         ; If statusbar
               add     ecx, 2            ; For border
         .endif
.if !TBHgt
      sub     ecx, 8 ;26
.endif
           push     ebx
         INVOKE     MoveWindow, hREdit, 0, edx, ebx, ecx, TRUE
            pop     ebx
         INVOKE     MoveWindow, hWndTool, 0, TBTop, ebx, TBHgt, TRUE

         .if hToolbarDlg
            INVOKE     GetWindowRect, hREdit, addr rect
              push     rect.top
              push     rect.left
            INVOKE     GetWindowRect, hToolbarDlg, addr rect
               mov     eax, rect.left
               sub     rect.right, eax
               mov     eax, rect.top
               sub     rect.bottom, eax
               pop     rect.left
               pop     rect.top
            INVOKE     MoveWindow, hToolbarDlg, rect.left, rect.top, rect.right, rect.bottom, TRUE
         .endif
         INVOKE     GetWindowRect, hWnd, addr rect
            mov     eax, rect.left
            sub     rect.right, eax
            mov     eax, rect.top
            sub     rect.bottom, eax
            mov     ecx, rect.right
         .if rect.right < 480 || rect.bottom != 402
            .if rect.right < 480
                  mov     ecx, 480
            .endif
            INVOKE     MoveWindow, hWnd, rect.left, rect.top, ecx, 402, TRUE
         .endif

      .elseif wmsg == WM_MOVE
         INVOKE     GetClientRect, hWnd, addr rect
            mov     edx, rect.bottom
            shl     edx, 16
            mov     ecx, rect.right
            mov     dx, cx
         INVOKE     SendMessage, hWnd, WM_SIZE, 0, edx

      .elseif wmsg == WM_NOTIFY
            mov     ebx, lparam          ; Get pointer to NMHDR
            mov     eax, (NMHDR ptr [ebx]).code
         .if eax == TTN_NEEDTEXT
               mov     eax, (NMHDR ptr [ebx]).idFrom ; Resource id
            .if hToolbarDlg
               INVOKE     GetData, hData, eax, 0
                  lea     eax, szTipA
            .else
                  mov     ebx, eax
               INVOKE     LoadString, hInst, ebx, addr szBuff, lengthof szBuff
                  mov     ebx, lparam                   ; Get the buffer addr
                  lea     eax, szBuff
            .endif
               mov     (TOOLTIPTEXT ptr [ebx]).lpszText, eax
               jmp     Ret0
         .endif
         jmp     DefWin

;---------- [System and user commands] ----------
      .elseif wmsg == WM_COMMAND

            mov     eax, wparam
           cwde                          ; Only low word contains command
         .if eax == IDM_EXIT
            INVOKE     SendMessage, hwnd, WM_CLOSE, 0 ,0

         .elseif eax == IDM_CUT
            INVOKE     SendMessage, hREdit, WM_CUT, 0 ,0

         .elseif eax == IDM_COPY
            INVOKE     SendMessage, hREdit, WM_COPY, 0 ,0

         .elseif eax == IDM_PASTE
            INVOKE     SendMessage, hREdit, WM_PASTE, 0 ,0

         .elseif eax == IDM_DELETE
            INVOKE     SendMessage, hREdit, WM_CLEAR, 0 ,0

         .elseif eax == IDM_SELALL
            INVOKE     SendMessage, hREdit, EM_SETSEL, 0, -1

         .elseif eax == IDM_TOOLBAR && !hToolbarDlg
            INVOKE     CreateDialogParam, hInst, IDD_DLG01, hwnd, addr ToolBarDlg, 0
               mov     hToolbarDlg, eax
            INVOKE     GetClientRect, hWnd, addr rect
               mov     edx, rect.bottom
               shl     edx, 16
               mov     ecx, rect.right
               mov     dx, cx
            INVOKE     SendMessage, hWnd, WM_SIZE, 0, edx

         .elseif eax == IDM_DIALOG
            INVOKE     IsWindowVisible, hToolbarDlg
            .if !eax
               INVOKE     ShowWindow, hToolbarDlg, SW_SHOWDEFAULT
                  mov     eax, offset szMenu1
                  mov     mii.dwTypeData, eax
            .else
               INVOKE     ShowWindow, hToolbarDlg, SW_HIDE
                  mov     eax, offset szMenu2
                  mov     mii.dwTypeData, eax
            .endif
            INVOKE     SetMenuItemInfo, hMenu, 2, TRUE, addr mii
            INVOKE     DrawMenuBar, hWnd

         .endif

      .elseif wmsg == WM_CLOSE
         INVOKE     SendMessage, hREdit, EM_GETMODIFY, 0, 0
         .if eax != 0
            INVOKE     MessageBox, NULL, addr szError2, addr AppName,
                       MB_YESNOCANCEL or MB_ICONEXCLAMATION or MB_SYSTEMMODAL
            .if eax == IDYES
                 call     SaveFile
               .if eax == IDCANCEL
                     jmp     Ret0
               .endif
            .elseif eax == IDCANCEL
                  jmp     Ret0
            .endif
         .endif
         INVOKE     DestroyWindow, hwnd

      .elseif wmsg == WM_DESTROY

            and     Incr, 0
         .while (BmpCnt)
               mov     eax, Incr
               mov     ecx, BmpArray[eax*4]
            INVOKE     DeleteObject, ecx
               inc     Incr
               dec     BmpCnt
         .endw

            and     Incr, 0
         .while (BmpCntM)
               mov     eax, Incr
               mov     ecx, BmpArrayM[eax*4]
            INVOKE     DeleteObject, ecx
               inc     Incr
               dec     BmpCntM
         .endw

            and     Incr, 0
            mov     Cnt, 11
         .while (Cnt)
               mov     eax, Incr
               mov     ecx, ToolArray[eax*4]
            INVOKE     HeapFree, hDefHeap, 0, ecx
.if eax == 0
;call     GetLastError
;DSPValue hWnd, eax, 1, 'm'
.endif
               inc     Incr
               dec     Cnt
         .endw

         INVOKE     ImageList_Destroy, hImageList
         INVOKE     ImageList_Destroy, hImageListM
         INVOKE     PostQuitMessage, NULL

      .else

DefWin:
         INVOKE     DefWindowProc, hwnd, wmsg, wparam, lparam
            ret
      .endif

Ret0:
         xor    eax, eax
         ret
WndProc endp

;======================================================
; SubClass the Edit control procedure
;======================================================
RichEditProc PROC hwnd:DWORD, wmsg, wparam, lparam
LOCAL    rect:RECT

      .if wmsg == WM_RBUTTONDOWN
            jmp     PopUp
      .endif
         jmp     ThatsAll

PopUp:
      INVOKE     GetWindowRect, hWnd, addr rect
         mov     ecx, lparam        ; x/y pos of window
         mov     ebx, ecx
         and     ebx, 0000ffffh     ; ebx = LOWORD(lparam) = x pos
         shr     ecx, 16            ; ecx = HIWORD(lparam) = y pos
         add     ebx, rect.left
         add     ecx, rect.top
         add     ebx, 10 
         add     ecx, 70
      INVOKE     TrackPopupMenu, hSMenu, TPM_LEFTALIGN or TPM_LEFTBUTTON,\
                 ebx, ecx, 0, hWnd, addr rect
        jmp      ThatsAll

ThatsAll:
      INVOKE     CallWindowProc, lpRichEdit, hwnd, wmsg, wparam, lparam

         ret
RichEditProc ENDP

;======================================================
; ChgBmpColor procedure
;======================================================
ChgBmpColor PROC hBitmap:DWORD, Code
LOCAL    mDC:DWORD, hBrush, hOldBmp, Fill, hOldBrush

      INVOKE     CreateCompatibleDC, NULL
         mov     mDC, eax
      INVOKE     SelectObject, mDC, hBitmap
         mov     hOldBmp, eax
      INVOKE     GetSysColor, COLOR_BTNFACE
      .if !Code
         INVOKE     CreateSolidBrush, 00ffffffh ;eax
      .else
         INVOKE     CreateSolidBrush, eax
      .endif
         mov     hBrush, eax
      INVOKE     SelectObject, mDC, hBrush
         mov     hOldBrush, eax
      .if !Code
            mov     Fill, 00c0c0c0h
      .else
            mov     Fill, 00ffffffh
      .endif
      INVOKE     ExtFloodFill, mDC, 0, 0, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 0, 15, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 15, 0, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 15, 15, Fill, FLOODFILLSURFACE
      INVOKE     SelectObject, mDC, hOldBrush
      INVOKE     DeleteObject, hBrush
      INVOKE     SelectObject, mDC, hBitmap
        push     eax
      INVOKE     DeleteDC, mDC
         pop     eax
         ret

ChgBmpColor ENDP

;======================================================
; Load Bitmaps procedure
;======================================================
LoadBitmaps PROC uses esi edi szBitMap:DWORD
LOCAL    hFile:DWORD, bytesread, MemPtr, hDC, hBitmap
LOCAL    szBuff[256]:BYTE, BmpHeader[27]:BYTE

         and     hBitmap, 0
      INVOKE     lstrcpy, addr szBuff, addr szRoot
      INVOKE     lstrcat, addr szBuff, addr szSlashB
      INVOKE     lstrcat, addr szBuff, addr szResr2
      INVOKE     lstrcat, addr szBuff, addr szSlashB
      INVOKE     lstrcat, addr szBuff, szBitMap

      INVOKE     CreateFile, addr szBuff, GENERIC_READ, FILE_SHARE_READ,\
                 0, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, 0
         cmp     eax, -1
          jz     NoFile      ; No File
         mov     hFile, eax

      INVOKE     ReadFile, hFile, addr BmpHeader, 26, addr bytesread, 0
         cmp     bytesread, 26
         jnz     NotBitmap   ; No read
         cmp     word ptr BmpHeader, 'MB'
         jnz     NotBitmap   ; Not Bitmap

      INVOKE     GlobalAlloc, 0, dword ptr BmpHeader+2 ; BmpHeader+2 = file size
          or     eax, eax
          jz     NotBitmap   ; No allocate
         mov     MemPtr, eax

      INVOKE     SetFilePointer, hFile, 0, 0, 0
      INVOKE     ReadFile, hFile, MemPtr, dword ptr BmpHeader+2, addr bytesread, 0

      INVOKE     GetDC, hWnd                           ; Get the dc of the window
         mov     hDC, eax
         mov     esi, MemPtr
         add     esi, dword ptr BmpHeader+10           ; Pointer to initialization data
         mov     edi, MemPtr
         add     edi, 14                               ; Pointer to bitmap size and format data
      INVOKE     CreateDIBitmap, hDC, edi, CBM_INIT, esi, edi, 0 ; Creates a device-dependent bitmap from a device-independent bitmap
      INVOKE     ChgBmpColor, eax, 0
         mov     hBitmap, eax

      INVOKE     GlobalFree, MemPtr

NotBitmap:
      INVOKE     CloseHandle, hFile

NoFile:
         mov     eax, hBitmap
         ret

LoadBitmaps ENDP

;======================================================
; Fill the DRAWITEM structure
;======================================================
SetDrawList PROC hwnd, hList, ID, Ctrl, Focus
LOCAL    rect:RECT

         mov     dis.CtlType, ODT_LISTBOX
         mov     eax, Ctrl
         mov     dis.CtlID, eax
       MOVmd     dis.itemID, ID
         mov     dis.itemAction, ODA_DRAWENTIRE
      .if Focus
            mov     dis.itemState, ODS_FOCUS
      .else
            mov     dis.itemState, ODS_DEFAULT ;ODS_DEFAULT ODS_FOCUS ODS_DISABLED
      .endif
         mov     eax, hList
         mov     dis.hwndItem, eax
      INVOKE     GetDC, hList
         mov     dis.hdc, eax
      INVOKE     SelectObject, dis.hdc, hFontL
      INVOKE     SendMessage, hList, LB_GETITEMRECT, ID, addr rect
       MOVmd     dis.rcItem.left, rect.left
       MOVmd     dis.rcItem.top, rect.top
       MOVmd     dis.rcItem.right, rect.right
       MOVmd     dis.rcItem.bottom, rect.bottom
         mov     dis.itemData, 0
      .if rect.top > 144 || rect.top > 7fffh
      .else
         INVOKE     SendMessage, hwnd, WM_DRAWITEM, Ctrl, addr dis
      .endif
      INVOKE     ReleaseDC, hList, dis.hdc
         ret
SetDrawList ENDP

;======================================================
; Load Listbox2 structure
;======================================================
LoadListbox2 PROC
LOCAL    Incr:DWORD, ID, bID, IDOn
LOCAL    szBuff1[32]:BYTE, szBuff2[32]:BYTE

         and     ID, 0
         and     bID, 0
         and     IDOn, 0
      INVOKE     IsDlgButtonChecked, hToolbarDlg,  IDC_RITIMID
      .if eax
         INVOKE     GetDlgItemInt, hToolbarDlg, IDC_ESTARTID, 0, 0
         .if !eax
               mov     eax, 1001
         .endif
            mov     bID, eax
            mov     IDOn, 1
      .endif

         mov     eax, BmpCntM
         and     Incr, 0
      .while (Incr < eax)
         .if Incr != 3 && Incr != 8 && Incr != 13
            .if !IDOn
                  mov     ecx, ID
                  mov     edx, dword ptr ToolSet[ecx*4]
               INVOKE     SendMessage, hListbox1, LB_GETTEXT, edx, addr szBuff2
               INVOKE     lstrcpy, addr szBuff1, addr szIDM
               INVOKE     lstrcat, addr szBuff1, addr szBuff2+4

            .else
               INVOKE     wsprintf, addr szBuff1, addr fmat1, bID
            .endif
               inc     ID
               inc     bID
         .else
            INVOKE     lstrcpy, addr szBuff1, addr szSpace
         .endif
         INVOKE     SendMessage, hListbox2, LB_ADDSTRING, 0, addr szBuff1

            mov     ecx, eax
            mov     edx, Incr
            mov     eax, BmpArrayM[edx*4]
         INVOKE     SendMessage, hListbox2, LB_SETITEMDATA, ecx, eax
            inc     Incr
            mov     eax, BmpCntM
      .endw

      INVOKE     SendMessage, hListbox2, LB_SETCURSEL, 10, 0
      INVOKE     SendMessage, hListbox2, LB_SETTOPINDEX, 0, 0
      INVOKE     SendMessage, hListbox2, LB_SETCURSEL, -1, 0

         ret
LoadListbox2 ENDP

;======================================================
; Get structure data
;======================================================
GetData PROC hBitmap:DWORD, ItemID, DelOn
LOCAL    Incr:DWORD, Cnt, IDOn, bID

         and     IDOn, 0
      INVOKE     IsDlgButtonChecked, hToolbarDlg,  IDC_RITIMID
      .if eax
            mov     IDOn, 1
      .endif

       MOVmd     Cnt, ArrayCnt
         and     Incr, 0

      .while (Cnt)
            mov     eax, ToolArray
            add     eax, Incr
         .if !ItemID
               add     eax, tshBitmap
               mov     edx, dword ptr[eax]
               mov     ecx, hBitmap
         .else
               mov     edx, dword ptr[eax]
               mov     ecx, ItemID
         .endif
         .if edx == ecx && edx != 1234
            .if !IDOn
                  mov     eax, ToolArray
                  add     eax, Incr
                  add     eax, tslpName
                  mov     ecx, eax
               INVOKE     lstrcpy, addr szNameA, ecx
            .else
                  mov     eax, ToolArray
                  add     eax, Incr
               INVOKE     wsprintf, addr szNameA, addr fmat1, dword ptr [eax]
            .endif
               mov     eax, ToolArray
               add     eax, Incr
               add     eax, tslpText
               mov     ecx, eax
            INVOKE     lstrcpy, addr szTextA, ecx

               mov     eax, ToolArray
               add     eax, Incr
               add     eax, tslpTip
               mov     ecx, eax
            INVOKE     lstrcpy, addr szTipA, ecx
            .if DelOn
                  mov     eax, ToolArray
                  add     eax, Incr
                  add     eax, tshBitmap
                  mov     dword ptr[eax], 9999
            .endif
            .break
         .endif
            mov     eax, StrSize
            add     Incr, eax
            dec     Cnt
      .endw

         ret
GetData ENDP

;======================================================
; Reset Listbox2
;======================================================
ResetListbox2 PROC
LOCAL    Incr:DWORD, Cnt, hBitmap

      INVOKE     SendMessage, hListbox2, LB_GETCOUNT, 0, 0
         mov     Cnt, eax
         and     Incr, 0
      .while (Cnt)
         INVOKE     SendMessage, hListbox2, LB_GETITEMDATA, Incr, 0
            mov     hBitmap, eax
         INVOKE     GetData, hBitmap, 0, 0
         INVOKE     SendMessage, hListbox2, LB_DELETESTRING, Incr, 0
         INVOKE     SendMessage, hListbox2, LB_INSERTSTRING, Incr, addr szNameA
         INVOKE     SendMessage, hListbox2, LB_SETITEMDATA, Incr, hBitmap
            inc     Incr
            dec     Cnt
      .endw

         ret
ResetListbox2 ENDP

;======================================================
; Load Imagelist
;======================================================
LoadImageList PROC Code:DWORD
LOCAL    Incr:DWORD, Cnt

      INVOKE     SendMessage, hListbox1, LB_GETCOUNT, 0, 0
         mov     Cnt, eax
         and     Incr, 0
      .while (Cnt)
         INVOKE     SendMessage, hListbox1, LB_GETITEMDATA, Incr, 0
         INVOKE     ChgBmpColor, eax, 1
            mov     hBmp, eax
         .if !Code
            INVOKE     ImageList_Add, hImageList, hBmp, 0
            INVOKE     ImageList_Add, hImageListM, hBmp, 0
         .endif
         INVOKE     ChgBmpColor, hBmp, 0
            inc     Incr
            dec     Cnt
      .endw

         ret
LoadImageList ENDP

;======================================================
; Set checkboxs PROCEDURE
;======================================================
SetCheck PROC

         INVOKE     SendMessage, hChk01, BM_SETCHECK, BST_UNCHECKED, 0
         INVOKE     SendMessage, hChk02, BM_SETCHECK, BST_UNCHECKED, 0
         INVOKE     SendMessage, hChk03, BM_SETCHECK, BST_UNCHECKED, 0
         INVOKE     SendMessage, hChk04, BM_SETCHECK, BST_UNCHECKED, 0
         INVOKE     SendMessage, hChk05, BM_SETCHECK, BST_UNCHECKED, 0
         INVOKE     SendMessage, hChk06, BM_SETCHECK, BST_UNCHECKED, 0
         INVOKE     SendMessage, hChk07, BM_SETCHECK, BST_UNCHECKED, 0
         INVOKE     SendMessage, hChk08, BM_SETCHECK, BST_UNCHECKED, 0
         INVOKE     SendMessage, hChk09, BM_SETCHECK, BST_CHECKED, 0
         INVOKE     SendMessage, hChk10, BM_SETCHECK, BST_UNCHECKED, 0

      .if (hToolStyle & TBSTYLE_FLAT)
         INVOKE     SendMessage, hChk01, BM_SETCHECK, BST_CHECKED, 0
      .endif
      .if (hToolStyle & CCS_NOPARENTALIGN)
         INVOKE     SendMessage, hChk02, BM_SETCHECK, BST_CHECKED, 0
      .endif
      .if (hToolStyle & TBSTYLE_LIST)
         INVOKE     SendMessage, hChk03, BM_SETCHECK, BST_CHECKED, 0
      .endif
      .if (hToolStyle & TBSTYLE_LIST)
         INVOKE     SendMessage, hChk04, BM_SETCHECK, BST_CHECKED, 0
      .endif
      .if (hToolStyle & CCS_NODIVIDER)
         INVOKE     SendMessage, hChk05, BM_SETCHECK, BST_CHECKED, 0
      .endif
      .if (hToolStyle & CCS_ADJUSTABLE)
         INVOKE     SendMessage, hChk06, BM_SETCHECK, BST_CHECKED, 0
      .endif
      .if (hToolStyle & CCS_NORESIZE)
         INVOKE     SendMessage, hChk07, BM_SETCHECK, BST_CHECKED, 0
      .endif
         mov     eax, hToolStyle
         and     eax, 0000000fh
      .if eax == 3 || eax == 7 || eax == 0bh || eax == 0fh
         INVOKE     SendMessage, hChk08, BM_SETCHECK, BST_CHECKED, 0
      .endif

         ret
SetCheck ENDP

;======================================================
; Set Toolbutton information PROCEDURE
;======================================================
SetInfo PROC
LOCAL    Incr:DWORD, Cnt

         and     Incr, 0
       MOVmd     Cnt, ArrayCnt
      .while (Cnt)
            mov     eax, ToolArray
            add     eax, Incr
            mov     edx, dword ptr[eax]
         .if edx
               add     eax, tsImageID
               mov     ecx, dword ptr[eax]
               mov     tbi.iImage, ecx
            .if NoImage
                  mov     tbi.iImage, 9999
            .endif
               mov     eax, ToolArray
               add     eax, Incr
               add     eax, tslpText
               mov     tbi.pszText, eax
            INVOKE     SendMessage, hWndTool, TB_SETBUTTONINFO, edx, addr tbi  ;edx = BtnID
         .endif
            mov     eax, StrSize
            add     Incr, eax
            dec     Cnt
      .endw

         ret
SetInfo ENDP

;======================================================
; Reset Toolbar PROCEDURE
;======================================================
ResetToolbar PROC

      INVOKE     SendMessage, hWndTool, TB_SETBITMAPSIZE, 0, bSize
      INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, bSize
        call     SetInfo
      INVOKE     SetWindowLong, hWndTool, GWL_STYLE, hToolStyle
        call     SetCheck

         ret
ResetToolbar ENDP

;======================================================
; Get Toolbar Text PROCEDURE
;======================================================
GetText PROC uses ebx esi edi
LOCAL    tbb:TBBUTTON
LOCAL    Incr:DWORD, Cnt, hBitmap

      INVOKE     SendMessage, hWndTool, TB_GETBUTTON, SelList2, addr tbb
;         mov     hBitmap, eax
      .if tbb.idCommand
;            mov     esi, ToolArray                ; Structure memory address
            mov     ecx, StrSize                  ; Size of the structure
            and     Incr, 0
          MOVmd     Cnt, ArrayCnt
         .while (Cnt)
               mov     eax, ToolArray
               add     eax, Incr
               mov     edx, dword ptr[eax]
            .if edx == tbb.idCommand
                  mov     eax, ToolArray
                  add     eax, Incr
                  add     eax, tslpTip
                  mov     edx, eax
                  and     EditOn, 0
               INVOKE     SendMessage, hEdit02, WM_SETTEXT, 0, edx
                  mov     eax, ToolArray
                  add     eax, Incr
                  add     eax, tslpText
                  mov     edx, eax
               INVOKE     SendMessage, hEdit01, WM_SETTEXT, 0, edx
                  mov     EditOn, 1
               .break
            .endif
               add     Incr, ecx
               dec     Cnt
         .endw
      .else
         INVOKE     SendMessage, hEdit01, WM_SETTEXT, 0, addr szNull
         INVOKE     SendMessage, hEdit02, WM_SETTEXT, 0, addr szNull
      .endif

         ret
GetText ENDP

;======================================================
; Edit or Add Toolbar Text PROCEDURE
;======================================================
EditAText PROC uses ebx esi edi
LOCAL    tbb:TBBUTTON
LOCAL    Incr:DWORD, Cnt
LOCAL    szBuff1[256]:BYTE, szBuff2[256]:BYTE

      INVOKE     SendMessage, hWndTool, TB_GETBUTTON, SelList2, addr tbb
      .if tbb.idCommand
            mov     esi, ToolArray                ; Structure memory address
            mov     ecx, StrSize                  ; Size of the structure
            and     Incr, 0
          MOVmd     Cnt, ArrayCnt
         .while (Cnt)
               mov     eax, ToolArray
               add     eax, Incr
               mov     edx, dword ptr[eax]
            .if edx == tbb.idCommand
               INVOKE     SendMessage, hEdit01, WM_GETTEXT, sizeof szBuff1, addr szBuff1
               INVOKE     SendMessage, hEdit02, WM_GETTEXT, sizeof szBuff2, addr szBuff2
                  mov     eax, ToolArray
                  add     eax, Incr
                  add     eax, tslpText
                  mov     edx, eax
               INVOKE     lstrcpy, edx, addr szBuff1
                  mov     eax, ToolArray
                  add     eax, Incr
                  add     eax, tslpTip
                  mov     edx, eax
               INVOKE     lstrcpy, edx, addr szBuff2

                  lea     eax, szBuff1
                  mov     tbi.pszText, eax
                  mov     eax, ToolArray
                  add     eax, Incr
                  mov     edx, dword ptr[eax]
                  add     eax, tsImageID
                  mov     ecx, dword ptr[eax]
                  mov     tbi.iImage, ecx
               INVOKE     SendMessage, hWndTool, TB_SETBUTTONINFO, edx, addr tbi
               .break
            .endif
               add     Incr, ecx
               dec     Cnt
         .endw
      .endif

         ret
EditAText ENDP

;======================================================
; esi = input string pointer ecx = len get before call
; returns string converted to lower case
;======================================================
LowerCase PROC

         xor     eax, eax
      .while ecx
         .if byte ptr[esi+eax] >= 'A' && byte ptr[esi+eax] <= 'Z'
;               and     byte ptr[esi+eax], 0dfh  ; and off lower case bit
               add     byte ptr[esi+eax], 20h   ; add 20h to upper case bit
         .endif
            inc     eax
            dec     ecx
      .endw
         ret

LowerCase ENDP

;======================================================
; Create Toolbar PROCEDURE
;======================================================
ToolBarDlg PROC uses ebx esi edi hdlg:DWORD, wmsg, wparam, lparam
LOCAL    rect:RECT
LOCAL    tbb:TBBUTTON
LOCAL    tbab:TBADDBITMAP
LOCAL    cm:COLORMAP
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    tm:TEXTMETRIC
LOCAL    hBrush:DWORD, ID, Cnt, Len, Ypos, hFind, hMemDC
LOCAL    Incr:DWORD, hList, hStyle, hBitmap
LOCAL    szBuff[256]:BYTE, szBuff1[32]:BYTE, szBuff2[32]:BYTE

      .if wmsg == WM_INITDIALOG

         INVOKE     CreatePopupMenu
            mov     hSMenu3, eax
            mov     mii.fType, MFT_STRING
            mov     mii.wID, IDM_DIALOG
;           push     hSMenu3
;            pop     mii.hSubMenu
            mov     mii.hSubMenu, 0
            mov     mii.dwItemData, 8040
            mov     eax, offset szMenu1
            mov     mii.dwTypeData, eax
         INVOKE     InsertMenuItem, hMenu, 2, TRUE, addr mii   ; Adds new menu
         INVOKE     DrawMenuBar, hWnd

            and     hData, 0
            and     EditOn, 0
            mov     StartID, 1001
         INVOKE     GetDlgItem, hdlg, IDC_STATIC01
            mov     hStat01, eax
         INVOKE     GetDlgItem, hdlg, IDC_STATIC03
            mov     ecx, eax
         INVOKE     SendMessage, ecx, WM_SETFONT, hFontD, TRUE

            and     Len, 0
            mov     Incr, 2001
            mov     Cnt, 29
         .while (Cnt)
            INVOKE     GetDlgItem, hdlg, Incr
               mov     ecx, Len
               mov     hListbox1[ecx*4], eax
               mov     ecx, eax
            .if Incr != 2025 && Incr != 2026 && Incr != 2028 && Incr != 2029
               INVOKE     SendMessage, ecx, WM_SETFONT, hFontD, TRUE
            .endif
               inc     Len
               inc     Incr
               dec     Cnt
         .endw

            and     Len, 0
            mov     Incr, 7001
            mov     Cnt, 9
         .while (Cnt)
            INVOKE     GetDlgItem, hdlg, Incr
               mov     ecx, eax
            .if Incr != 7001 && Incr != 7002 && Incr != 7004 && Incr != 7007
               INVOKE     SendMessage, ecx, WM_SETFONT, hFontD, TRUE
            .endif
               inc     Incr
               dec     Cnt
         .endw

         INVOKE     SendMessage, hEdit01, EM_LIMITTEXT, 31, 0 ; Limit text size
         INVOKE     SendMessage, hEdit02, EM_LIMITTEXT, 63, 0
         INVOKE     SendMessage, hEdit03, EM_LIMITTEXT, 31, 0
         INVOKE     SendMessage, hRad02, BM_SETCHECK, BST_CHECKED, 0
           call     SetCheck

         INVOKE     EnableWindow, hButt01, 0
         INVOKE     EnableWindow, hButt02, 0
         INVOKE     EnableWindow, hButt03, 0
         INVOKE     EnableWindow, hButt04, 0
         INVOKE     EnableWindow, hButt05, 0
         INVOKE     EnableWindow, hEdit01, 0
         INVOKE     EnableWindow, hEdit02, 0
         INVOKE     EnableWindow, hEdit03, 0
         INVOKE     SetDlgItemInt, hdlg, IDC_ESTARTID, StartID, 0
         INVOKE     SetDlgItemInt, hdlg, IDC_ECHANGEW, 23, 0

         .if !BmpCnt
            INVOKE     SendMessage, hListbox1, LB_ADDSTRING, 0, addr szSpace
            INVOKE     SendMessage, hListbox1, LB_SETITEMDATA, 0, 1234
         .endif

         INVOKE     ImageList_Create, 16, 16, ILC_COLOR32, 36, 32
            mov     hImageListM, eax

;---------- [Set the Font and the line height of the Listbox] ----------
         INVOKE     SendMessage, hListbox1, WM_SETFONT, hFontL, 1
         INVOKE     SendMessage, hListbox2, WM_SETFONT, hFontL, 1

;---------- [Get the current dir and load the Listbox with its files] ----------
         INVOKE     GetCurrentDirectory, lengthof szRoot, addr szRoot
         INVOKE     lstrcat, addr szRoot, addr szSlashB
         INVOKE     lstrcpy, addr szBuff, addr szRoot

         INVOKE     lstrcat, addr szBuff, addr szResr2
         INVOKE     lstrcat, addr szBuff, addr szSlashB
         INVOKE     lstrcat, addr szBuff, addr szAll
         INVOKE     FindFirstFile, addr szBuff, addr FindData
           test     eax, eax
             js     NoFile
            mov     hFind, eax
            jmp     Addem

Getem:
         INVOKE     FindNextFile, hFind, addr FindData
           test     eax, eax
             jz     AllDone

Addem:
         .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) ||\
             (FindData.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN) ||\
             (FindData.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM) ||\
             byte ptr FindData.cFileName != 'B' && byte ptr FindData.cFileName != 'S'
               jmp     Getem
         .endif
         INVOKE     lstrlen, addr FindData.cFileName
            sub     eax, 3
         INVOKE     lstrcpyn, addr szBuff, addr FindData.cFileName, eax
         INVOKE     SendMessage, hListbox1, LB_ADDSTRING, 0, addr szBuff ;FindData.cFileName
           push     eax
         INVOKE     LoadBitmaps, addr FindData.cFileName
            pop     ecx
         INVOKE     SendMessage, hListbox1, LB_SETITEMDATA, ecx, eax
            jmp     Getem

AllDone:
         INVOKE     FindClose, hFind
         INVOKE     SendMessage, hListbox1, LB_SETCURSEL, 10, 0
         INVOKE     SendMessage, hListbox1, LB_SETTOPINDEX, 0, 0
         INVOKE     SendMessage, hListbox1, LB_SETCURSEL, -1, 0

         INVOKE     LoadImageList, 0

         INVOKE     SendMessage, hWndTool, TB_SETIMAGELIST, 0, hImageListM
         INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
            mov     Cnt, eax
            mov     Incr, eax
            dec     Incr
         .while (Cnt)
            INVOKE     SendMessage, hWndTool, TB_DELETEBUTTON, Incr, 0
               dec     Incr
               dec     Cnt
         .endw
         TBButt     hWndTool, 0, 1001, 0
         TBButt     hWndTool, 1, 1002, 0
         TBButt     hWndTool, 2, 1003, 0
          TBSep     hWndTool
         TBButt     hWndTool, 4, 1004, 0
         TBButt     hWndTool, 5, 1005, 0
         TBButt     hWndTool, 6, 1006, 0
         TBButt     hWndTool, 7, 1007, 0
          TBSep     hWndTool
         TBButt     hWndTool, 10,1008, 0
         TBButt     hWndTool, 11,1009, 0
         TBButt     hWndTool, 12,1010, 0
         TBButt     hWndTool, 13,1011, 0
          TBSep     hWndTool
         TBButt     hWndTool, 15,1012, 0
            mov     ImageID, 1

NoFile:
;---------- [Reload the master Bitmap array in sequence] ---------
         INVOKE     SendMessage, hListbox1, LB_GETCOUNT, 0, 0
            mov     Cnt, eax
            and     BmpCnt, 0
         .while (Cnt)
               mov     eax, BmpCnt
            INVOKE     SendMessage, hListbox1, LB_GETITEMDATA, eax, 0
               mov     ecx, BmpCnt
               mov     BmpArray[ecx*4], eax
               inc     BmpCnt
               dec     Cnt
         .endw

;---------- [Load the Toolbar Bitmap array] ---------
            and     BmpCntM, 0
            and     ID, 0
            mov     Cnt, 12           ; Number of bitmaps
         .while (Cnt)
               mov     ecx, ID
              imul     ecx, 4
               mov     eax, dword ptr ToolSet[ecx]
            INVOKE     SendMessage, hListbox1, LB_GETITEMDATA, eax, 0
               mov     ecx, BmpCntM
               mov     BmpArrayM[ecx*4], eax
               inc     BmpCntM
            .if BmpCntM == 3 || BmpCntM == 8 || BmpCntM == 13
                  mov     ecx, BmpCntM
                  mov     BmpArrayM[ecx*4], 1234  ; Seperator code
                  inc     BmpCntM
            .endif
               dec     Cnt
               inc     ID
         .endw

           call     LoadListbox2

;---------- [Load the ToolStructure into memory] ----------
            and     ArrayCnt, 0
            mov     ButtID, 1001
            and     Incr, 0
            lea     ecx, offset ts
            mov     eax, sizeof ts
            mov     StrSize, eax
            mov     StrAddr, ecx

         .while (ArrayCnt < 12)
             MOVmd     ts.ID, ButtID
               mov     eax, Incr
               mov     ecx, dword ptr ToolSet[eax*4]
               dec     ecx
               mov     ts.ImageID, ecx
inc     ecx
            INVOKE     SendMessage, hListbox1, LB_GETITEMDATA, ecx, 0
               mov     ts.hBitmap, eax

               mov     ecx, ts.ImageID
inc     ecx
            INVOKE     SendMessage, hListbox1, LB_GETTEXT, ecx, addr szBuff2
            INVOKE     lstrcpy, addr szBuff1, addr szIDM
               mov     ecx, 4
            .if byte ptr szBuff2 == 'S'
                  mov     ecx, 7
            .endif
            INVOKE     lstrcat, addr szBuff1, addr szBuff2[ecx]
            INVOKE     lstrcpy, addr ts.lpName, addr szBuff1
               mov     eax, Incr
            INVOKE     lstrcpy, addr ts.lpText, szText[eax*4]
               mov     eax, Incr
            INVOKE     lstrcpy, addr ts.lpTip, szTip[eax*4]
               mov     esi, StrAddr                  ; Address of the structure
               mov     ecx, StrSize                  ; Size of the structure
               mov     edi, ToolArray                ; Structure memory address
               mov     eax, ArrayCnt
              imul     eax, ecx
               add     edi, eax                      ; Offset the number of structures
               rep     movsb                         ; Load the structure
               inc     ArrayCnt
               inc     ButtID
               inc     Incr
         .endw

;---------- [Backup the array] ----------
            mov     ecx, StrSize
           imul     ecx, ArrayCnt
            mov     esi, ToolArray
            mov     edi, ToolArrayM
            rep     movsb

            inc     ArrayCnt

         INVOKE     SetFocus, hStat01

      .elseif wmsg == WM_DRAWITEM
         .if wparam == 2001 || wparam == 2002
               mov     esi, lparam
               lea     edi, dis
               mov     ecx, sizeof dis
               rep     movsb
            .if dis.itemID != -1
               .if wparam == 2001
                    push     hListbox1
               .else
                    push     hListbox2
               .endif
                  pop     hList
               INVOKE     SendMessage, hList, LB_GETTEXT, dis.itemID, addr szBuff
                  mov     Len, eax
               INVOKE     SendMessage, hList, LB_GETITEMDATA, dis.itemID, 0
                  mov     hBmp, eax
               .if eax == 1234
                  INVOKE     lstrcpy, addr szBuff, addr szSep
                  INVOKE     lstrlen, addr szBuff
                     mov     Len, eax
               .endif
               INVOKE     GetTextMetrics, dis.hdc, addr tm
                  mov     eax, dis.rcItem.bottom
                  add     eax, dis.rcItem.top
                  sub     eax, tm.tmHeight
                  shr     eax, 1
                  mov     Ypos, eax

               .if (dis.itemState & ODS_SELECTED)
                  INVOKE     CreateSolidBrush, 00800000h      ; Highlight background color
                     mov     hBrush, eax
                  INVOKE     FillRect, dis.hdc, addr dis.rcItem, eax
                  INVOKE     SetTextColor, dis.hdc, 00ffffffh ; Highlight text color
                  INVOKE     SetBkColor, dis.hdc, 00800000h   ; Highlight text background color
               .else
                  INVOKE     CreateSolidBrush, 00ffffffh      ; Background color
                     mov     hBrush, eax
                  INVOKE     FillRect, dis.hdc, addr dis.rcItem, eax
                  INVOKE     SetTextColor, dis.hdc, 00ff0000h ; Text color - dis.itemData
                  INVOKE     SetBkColor, dis.hdc, 00ffffffh   ; Text background color
               .endif
                  add     dis.rcItem.left, 20
               INVOKE     TextOut, dis.hdc, dis.rcItem.left, Ypos, addr szBuff, Len
                  sub     dis.rcItem.left, 19
                  mov     dis.rcItem.right, 17
               INVOKE     DeleteObject, hBrush

               .if hBmp != 1234
                  INVOKE     CreateCompatibleDC, dis.hdc      ; Create a compatible dc in memory
                     mov     hMemDC, eax
                  INVOKE     SelectObject, hMemDC, hBmp       ; Select the opened bitmap into the dc
                  INVOKE     BitBlt, dis.hdc, 0, dis.rcItem.top, 16, 16, hMemDC, 0, 0, SRCCOPY ;Copy the bitmap
                  INVOKE     DeleteDC, hMemDC                 ; Delete the memory dc
;                  INVOKE     ReleaseDC, hButt, dis.hdc        ; Release the control dc
               .endif

            .endif
               mov     dis.itemState, ODS_DEFAULT
               mov     dis.hdc, 0
         .endif

      .elseif wmsg == WM_COMMAND
         .if wparam == IDCANCEL
               jmp     CloseIt
         .endif
            mov     eax, wparam
            shr     eax, 16
            mov     ebx, wparam
            and     ebx, 0ffffh
            mov     wparam, ebx


;---------- [Extract the selected item] ----------
         .if eax == LBN_SELCHANGE
            INVOKE     SendMessage, lparam, LB_GETCURSEL, 0, 0
            .if eax == LB_ERR
                  jmp     DlgDone
            .endif
               mov     ecx, eax
               mov     eax, lparam
            .if eax == hListbox1
                  mov     SelList1, ecx
                  and     EditOn, 0
                  and     hData, 0
                  and     CmdID, 0
               INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
               .if eax
                  INVOKE     EnableWindow, hButt01, 1
               .endif
               INVOKE     EnableWindow, hButt02, 1
               INVOKE     EnableWindow, hButt03, 0
               INVOKE     EnableWindow, hButt04, 0
               INVOKE     EnableWindow, hButt05, 0
               INVOKE     EnableWindow, hEdit01, 0
               INVOKE     EnableWindow, hEdit02, 0
               INVOKE     EnableWindow, hEdit03, 0
               INVOKE     SendMessage, hEdit01, WM_SETTEXT, 0, addr szNull
               INVOKE     SendMessage, hEdit02, WM_SETTEXT, 0, addr szNull
               INVOKE     SendMessage, hEdit03, WM_SETTEXT, 0, addr szNull

               INVOKE     SendMessage, hListbox2, LB_GETCURSEL, 0, 0
               .if eax != LB_ERR
                  INVOKE     SetDrawList, hdlg, hListbox2, eax, 2002, 1
                  INVOKE     RedrawWindow, hListbox1, 0, 0,\
                             RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
               .endif

            .else
                  mov     SelList2, ecx
                  and     CmdID, 0
               INVOKE     EnableWindow, hButt01, 0
               INVOKE     EnableWindow, hButt02, 0
               INVOKE     EnableWindow, hButt03, 1
               INVOKE     EnableWindow, hButt04, 1
               INVOKE     EnableWindow, hButt05, 1
               INVOKE     SendMessage, hListbox2, LB_GETTEXT, SelList2, addr szBuff
               INVOKE     SendMessage, hListbox2, LB_GETITEMDATA, SelList2, 0
               .if eax != 1234
                  INVOKE     EnableWindow, hEdit01, 1
                  INVOKE     EnableWindow, hEdit02, 1
                  INVOKE     EnableWindow, hEdit03, 1
                  INVOKE     SendMessage, hEdit03, WM_SETTEXT, 0, addr szBuff
                     mov     EditOn, 1
               .else
                  INVOKE     EnableWindow, hEdit01, 0
                  INVOKE     EnableWindow, hEdit02, 0
                  INVOKE     EnableWindow, hEdit03, 0
                  INVOKE     SendMessage, hEdit03, WM_SETTEXT, 0, addr szNull
                     and     EditOn, 0
               .endif
                  and     hData, 0
               INVOKE     SendMessage, hListbox1, LB_GETCURSEL, 0, 0
               .if eax != LB_ERR
                  INVOKE     SetDrawList, hdlg, hListbox1, eax, 2001, 0
                  INVOKE     RedrawWindow, hListbox2, 0, 0,\
                             RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
               .endif
                 call     GetText
            .endif


         .elseif eax == EN_CHANGE
            .if wparam == IDC_ETOOLTEXT && EditOn || wparam == IDC_ETOOLTIP && EditOn
                 call     EditAText

            .elseif wparam == IDC_EIDNAME && EditOn
               INVOKE     SendMessage, hEdit03, WM_GETTEXT, 256, addr szBuff
               INVOKE     SendMessage, hListbox2, LB_GETITEMDATA, SelList2, 0
                  mov     hBitmap, eax
               INVOKE     SendMessage, hListbox2, LB_DELETESTRING, SelList2, 0
               INVOKE     SendMessage, hListbox2, LB_INSERTSTRING, SelList2, addr szBuff
               INVOKE     SendMessage, hListbox2, LB_SETCURSEL, SelList2, 0
               INVOKE     SendMessage, hListbox2, LB_SETITEMDATA, SelList2, hBitmap

                MOVmd     Cnt, ArrayCnt
                  and     Incr, 0

               .while (Cnt)
                     mov     eax, ToolArray
                     add     eax, Incr
                     add     eax, tshBitmap
                     mov     edx, dword ptr[eax]
                  .if edx == hBitmap && edx != 1234
                     INVOKE     IsDlgButtonChecked, hToolbarDlg,  IDC_RITIMID
                     .if eax
                        INVOKE     GetDlgItemInt, hToolbarDlg, IDC_EIDNAME, 0, 0
                           mov     ecx, ToolArray
                           add     ecx, Incr
                        .if !CmdID
                            MOVmd     CmdID, dword ptr[ecx]
                        .endif
                           mov     dword ptr[ecx], eax

;---------- [Update the Command ID for the toolbar button] ----------
                           mov     ecx, eax
                          push     tbi.dwMask
                           mov     tbi.dwMask, TBIF_COMMAND
                           mov     tbi.idCommand, ecx
                        INVOKE     SendMessage, hWndTool, TB_SETBUTTONINFO, CmdID, addr tbi  ;edx = BtnID
                         MOVmd     CmdID, tbi.idCommand
                           pop     tbi.dwMask

                     .else
                           mov     eax, ToolArray
                           add     eax, Incr
                           add     eax, tslpName
                           mov     ecx, eax
                        INVOKE     lstrcpy, ecx, addr szBuff
                     .endif
                     .break
                  .endif
                     mov     eax, StrSize
                     add     Incr, eax
                     dec     Cnt
               .endw

            .endif


;---------- [ IDC_RITIMID and IDC_RNAME = ID or name for listbox] ----------
         .elseif wparam ==  IDC_RITIMID || wparam == IDC_RNAME
               and     hData, 0
            INVOKE     SendMessage, hListbox2, LB_GETCURSEL, 0, 0
               mov     SelList2, eax
              call     ResetListbox2
            .if SelList2 != LB_ERR
               INVOKE     SendMessage, hListbox2, LB_SETCURSEL, SelList2, 0
               INVOKE     SendMessage, hListbox2, LB_GETTEXT, SelList2, addr szBuff
               INVOKE     SendMessage, hEdit03, WM_SETTEXT, 0, addr szBuff
            .endif


;---------- [IDC_CHK01 = Flat] ----------
         .elseif wparam == IDC_CHK01
            INVOKE     SendMessage, hdlg, WM_COMMAND, IDC_BSTYLESU, 0


;---------- [IDC_CHK03 = bitmap & text] ----------
         .elseif wparam == IDC_CHK03
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK03
            .if !eax
               INVOKE     SendMessage, hChk04, BM_SETCHECK, BST_UNCHECKED, 0
;               INVOKE     SendMessage, hEdit01, WM_SETTEXT, 0, addr szNull
            .else
               INVOKE     IsWindowEnabled, hButt03
               .if eax
                    call     GetText
               .endif
            .endif
            INVOKE     SendMessage, hdlg, WM_COMMAND, IDC_BSTYLESU, 0


;---------- [IDC_CHK04 = text only] ----------
         .elseif wparam == IDC_CHK04
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK04
            .if eax
               INVOKE     IsWindowEnabled, hButt03
               .if eax
                    call     GetText
               .endif
               INVOKE     SendMessage, hChk03, BM_SETCHECK, BST_CHECKED, 0
            .endif
            INVOKE     SendMessage, hdlg, WM_COMMAND, IDC_BSTYLESU, 0


;---------- [IDC_CHK09 = Sample buttons] ----------
         .elseif wparam == IDC_CHK09
            INVOKE     SetFocus, hStat01
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK09
            .if eax
                  and     Chk10On, 0
                  and     AddOn, 0
               INVOKE     SendMessage, hChk10, BM_SETCHECK, BST_UNCHECKED, 0
               INVOKE     SendMessage, hdlg, WM_COMMAND, IDC_BRESTORE, 0

            .else
               INVOKE     SendMessage, hChk10, BM_SETCHECK, BST_CHECKED, 0
            .endif


;---------- [IDC_CHK10 = Remove buttons] ----------
         .elseif wparam == IDC_CHK10
            INVOKE     SetFocus, hStat01
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK10
            .if eax
               INVOKE     SendMessage, hChk09, BM_SETCHECK, BST_UNCHECKED, 0
               INVOKE     SendMessage, hListbox2, LB_RESETCONTENT, 0, 0
                  and     ArrayCnt, 0
                  mov     SelList2, 0
                  mov     Chk10On, 1
                  mov     AddOn, 1
               INVOKE     GetDlgItemInt, hToolbarDlg, IDC_ESTARTID, 0, 0
               .if !eax
                     mov     eax, 1001
               .endif
                  mov     ButtID, eax

               INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
                  mov     Cnt, eax
                  mov     Incr, eax
                  dec     Incr
               .while (Cnt)
                  INVOKE     SendMessage, hWndTool, TB_DELETEBUTTON, Incr, 0
                     dec     Incr
                     dec     Cnt
               .endw

            .else
               INVOKE     SendMessage, hChk09, BM_SETCHECK, BST_CHECKED, 0
            .endif


;---------- [IDC_BINSERT = insert new button  IDC_BADD = add new button to end] ----------
         .elseif wparam == IDC_BINSERT || wparam == IDC_BADD
               and     AddOn, 0
            .if wparam == IDC_BADD
                  mov     AddOn, 1
            .endif
            INVOKE     SetFocus, hStat01
            INVOKE     SendMessage, hListbox1, LB_GETCURSEL, 0, 0
               mov     SelList1, eax
            INVOKE     SendMessage, hListbox1, LB_GETITEMDATA, eax, 0
              push     eax

            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK10
            .if !eax
               INVOKE     SendMessage, hListbox2, LB_GETCURSEL, 0, 0
               .if eax == LB_ERR
                     pop     eax
                     jmp     DlgDone
               .else
                     mov     SelList2, eax
               .endif
            .else
               INVOKE     SendMessage, hListbox2, LB_GETCURSEL, 0, 0
               .if eax != LB_ERR
                     mov     SelList2, eax
               .endif
            .endif


            INVOKE     IsDlgButtonChecked, hToolbarDlg,  IDC_RITIMID
            .if eax
               INVOKE     SendMessage, hListbox1, LB_GETTEXT, SelList1, addr szBuff2
                  mov     ecx, 4
               .if byte ptr szBuff2 == 'S'
                     mov     ecx, 7
               .endif
               INVOKE     lstrcpyn, addr szTextA, addr szBuff2[ecx], 6
                  mov     ecx, 4
                  lea     esi, szTextA
                 call     LowerCase               ; Convert to lowercase
                  and     byte ptr szTextA, 0dfh  ; and off lower case bit
               INVOKE     wsprintf, addr szBuff1, addr fmat1, ButtID
            .else
               INVOKE     SendMessage, hListbox1, LB_GETTEXT, SelList1, addr szBuff2
               INVOKE     lstrcpy, addr szBuff1, addr szIDM
                  mov     ecx, 4
               .if byte ptr szBuff2 == 'S'
                     mov     ecx, 7
               .endif
                 push     ecx
               INVOKE     lstrcat, addr szBuff1, addr szBuff2[ecx]
                  pop     ecx
               INVOKE     lstrcpyn, addr szTextA, addr szBuff2[ecx], 6
                  mov     ecx, 4
                  lea     esi, szTextA
                 call     LowerCase               ; Convert to lowercase
                  and     byte ptr szTextA, 0dfh  ; and off lower case bit
            .endif

            INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
            .if !AddOn
               INVOKE     SendMessage, hListbox2, LB_INSERTSTRING, SelList2, addr szBuff1
            .else
               INVOKE     SendMessage, hListbox2, LB_ADDSTRING, 0, addr szBuff1
                  mov     SelList2, eax
                  mov     eax, 00100010h
               INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, eax
            .endif

               pop     edx
            INVOKE     SendMessage, hListbox2, LB_SETITEMDATA, SelList2, edx
               mov     ecx, SelList2
            .if !AddOn
                  inc     ecx
            .endif
            INVOKE     SendMessage, hListbox2, LB_SETCURSEL, ecx, 0
            INVOKE     SetFocus, hListbox1
               mov     eax, SelList1
               dec     eax

AddTool:
            .if Chk10On
                  lea     ebx, szTextA
            .else
                  xor     ebx, ebx
            .endif
               mov     edx, TBSTYLE_BUTTON
            .if SelList1 == 9999
                  lea     ebx, szTextA
                  mov     ecx, tbb.idCommand
            .elseif SelList1
                  mov     ecx, ButtID
                  inc     ButtID
            .endif
            .if !SelList1
                  xor     eax, eax
                  xor     ecx, ecx
                  mov     edx, TBSTYLE_SEP
            .endif
               mov     tbb.iBitmap, eax           ; Button image number
               mov     tbb.idCommand, ecx         ; Command ID number
               mov     tbb.fsState, TBSTATE_ENABLED
               mov     tbb.fsStyle, dl
               mov     tbb.dwData, 0
               mov     tbb.iString, ebx           ; Text string
              push     eax
              push     ecx
            INVOKE     SendMessage, hWndTool, TB_GETITEMRECT, 0, addr rect
            INVOKE     SendMessage, hWndTool, TB_INSERTBUTTON, SelList2, addr tbb
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK03
            .if !eax
                  mov     ecx, rect.bottom
                  mov     eax, rect.right
               .if eax > 100
                     mov     eax, 23
               .endif
                  mov     cx, ax
               INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, ecx
            .endif

;---------- [Text only] ----------
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK04
            .if eax
                  lea     ebx, szTextA
                  pop     ecx
                 push     ecx
                  mov     tbi.dwMask, TBIF_IMAGE or TBIF_TEXT
                  mov     tbi.iImage, 9999
                  mov     tbi.pszText, ebx ;0
               INVOKE     SendMessage, hWndTool, TB_SETBUTTONINFO, ecx, addr tbi
               INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, SavSize
            .endif

               pop     ecx
               pop     eax

;---------- [Add new tool button to the array] ----------
            .if SelList1 && SelList1 != 9999
                  mov     ts.ID, ecx
                  mov     ts.ImageID, eax
               INVOKE     SendMessage, hListbox2, LB_GETITEMDATA, SelList2, 0
                  mov     ts.hBitmap, eax
               INVOKE     SendMessage, hListbox1, LB_GETTEXT, SelList1, addr szBuff2
               INVOKE     lstrcpy, addr szBuff1, addr szIDM
                  mov     ecx, 4
               .if byte ptr szBuff2 == 'S'
                     mov     ecx, 7
               .endif
                 push     ecx
               INVOKE     lstrcat, addr szBuff1, addr szBuff2[ecx]
                  pop     ecx
               INVOKE     lstrcpyn, addr szTextA, addr szBuff2[ecx],6
                  mov     ecx, 4
                  lea     esi, szTextA
                 call     LowerCase               ; Convert to lowercase
                  and     byte ptr szTextA, 0dfh  ; and off lower case bit
               INVOKE     lstrcpy, addr ts.lpName, addr szBuff1
               INVOKE     lstrcpy, addr ts.lpText, addr szTextA
                  mov     byte ptr ts.lpTip, 0
                  mov     esi, StrAddr                  ; Address of the structure
                  mov     ecx, StrSize                  ; Size of the structure
                  mov     edi, ToolArray                ; Structure memory address
                  mov     eax, ArrayCnt
                 imul     eax, ecx
                  add     edi, eax                      ; Offset the number of structures
                  rep     movsb                         ; Load the structure
                  inc     ArrayCnt
            .endif


;---------- [IDC_BREMOVE = remove button] ----------
         .elseif wparam == IDC_BREMOVE
            INVOKE     SetFocus, hStat01
            INVOKE     SendMessage, hListbox2, LB_GETCURSEL, 0, 0
            .if eax == LB_ERR
                  jmp     DlgDone
            .endif
               mov     SelList2, eax
            INVOKE     SendMessage, hListbox2, LB_GETITEMDATA, SelList2, 0
               mov     hData, eax
            INVOKE     GetData, hData, 0, 1
            INVOKE     SendMessage, hListbox2, LB_DELETESTRING, SelList2, 0
            INVOKE     SendMessage, hWndTool, TB_DELETEBUTTON, SelList2, 0
               and     hData, 0

               dec     SelList2
            INVOKE     SendMessage, hListbox2, LB_SETCURSEL, SelList2, 0


;---------- [IDC_BMOVEU and IDC_BMOVED = shift up & shift down] ----------
         .elseif wparam == IDC_BMOVEU || wparam == IDC_BMOVED
            INVOKE     SetFocus, hStat01
            INVOKE     SendMessage, hListbox2, LB_GETCURSEL, 0, 0
            .if eax == LB_ERR
                  jmp     DlgDone
            .endif
               mov     SelList2, eax
            INVOKE     SendMessage, hWndTool, TB_GETBUTTON, SelList2, addr tbb
            INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
               dec     eax
               mov     Cnt, eax
               mov     eax, SelList2
            .if wparam == IDC_BMOVEU && eax == 0 || wparam == IDC_BMOVED && eax >= Cnt
                  jmp     DlgDone
            .endif
            .if !hData
               INVOKE     SendMessage, hListbox2, LB_GETITEMDATA, SelList2, 0
                  mov     hData, eax
               INVOKE     GetData, hData, 0, 0
            .endif
            INVOKE     SendMessage, hListbox2, LB_DELETESTRING, SelList2, 0
            INVOKE     SendMessage, hWndTool, TB_DELETEBUTTON, SelList2, 0
            .if wparam == IDC_BMOVEU
                  dec     SelList2
            .else
                  inc     SelList2
            .endif
            INVOKE     SendMessage, hListbox2, LB_INSERTSTRING, SelList2, addr szNameA
            INVOKE     SendMessage, hListbox2, LB_SETITEMDATA, SelList2, hData
            INVOKE     SendMessage, hListbox2, LB_SETCURSEL, SelList2, 0

               mov     eax, tbb.iBitmap
               mov     SelList1, 9999
            .if hData == 1234
                  and     SelList1, 0
            .endif
               jmp     AddTool


;---------- [IDC_BSTYLESU = update and IDC_BSTYLESR = reset] ----------
         .elseif wparam == IDC_BSTYLESU || wparam == IDC_BSTYLESR
            .if wparam == IDC_BSTYLESR
                  jmp     Pass
            .endif
               mov     ecx, WS_CHILD or WS_VISIBLE or WS_BORDER or TBSTYLE_TOOLTIPS or CCS_TOP
               mov     hStyle, ecx
               mov     TBTop, -4
               mov     TBHgt, 28
               mov     eax, 00120010h
            INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, eax
               mov     eax, 00100010h
            INVOKE     SendMessage, hWndTool, TB_SETBITMAPSIZE, 0, eax
               mov     tbi.dwMask, TBIF_IMAGE
               and     NoImage, 0
              call     SetInfo
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK01
            .if eax
                   or     hStyle, TBSTYLE_FLAT
                  mov     TBTop, -2
                  mov     TBHgt, 26
                  mov     eax, 00100010h
               INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, eax
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK02
            .if eax
                   or     hStyle, CCS_NOPARENTALIGN
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK03
            .if eax
                  and     NoImage, 0
                   or     hStyle, TBSTYLE_LIST
                  mov     eax, 0010003ah
               INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, eax
                  mov     tbi.dwMask, TBIF_IMAGE or TBIF_TEXT
               INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK04
               .if eax
                     mov     NoImage, 1
                     mov     eax, 00100000h
                  INVOKE     SendMessage, hWndTool, TB_SETBITMAPSIZE, 0, eax
                     mov     eax, 00100030h
                     mov     SavSize, eax
                  INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, eax
               .endif
                 call     SetInfo
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK04
            .if eax
                   or     hStyle, TBSTYLE_LIST
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK05
            .if eax
                   or     hStyle, CCS_NODIVIDER
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK06
            .if eax
                   or     hStyle, CCS_ADJUSTABLE
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK07
            .if eax
                   or     hStyle, CCS_NORESIZE
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, IDC_CHK08
            .if eax
                  and     hStyle, 0fffffff0h
                   or     hStyle, CCS_BOTTOM
                  mov     TBHgt, 0
            .endif

Pass:
            .if wparam == IDC_BSTYLESU
               INVOKE     SetWindowLong, hWndTool, GWL_STYLE, hStyle
            .else
                  mov     TBTop, -2
                  mov     TBHgt, 26
                  mov     tbi.dwMask, TBIF_IMAGE
                  and     NoImage, 0
                 call     ResetToolbar
            .endif

            .if TBHgt
               INVOKE     ShowWindow, hWndStat, SW_SHOWDEFAULT
            .else
               INVOKE     ShowWindow, hWndStat, SW_HIDE
            .endif

            INVOKE     GetClientRect, hWnd, addr rect
               mov     edx, rect.bottom
               shl     edx, 16
               mov     ecx, rect.right
               mov     dx, cx
            INVOKE     SendMessage, hWnd, WM_SIZE, 0, edx
            INVOKE     RedrawWindow, hWndTool, 0, 0,\
                       RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW

            INVOKE     SetFocus, hStat01
            .if !Redo
                  mov     Redo, 1
               INVOKE     SendMessage, hdlg, WM_COMMAND, wparam, 0
            .endif
               and     Redo, 0
            
            INVOKE     SendMessage, hWndTool, TB_GETITEMRECT, 0, addr rect
            .if rect.right < 23 || rect.right > 100
                  mov     rect.right, 23
            .endif
            INVOKE     SetDlgItemInt, hdlg, IDC_ECHANGEW, rect.right, 0


;---------- [IDC_BRESTORE = restore] ----------
         .elseif wparam == IDC_BRESTORE
               and     hData, 0
               and     Chk10On, 0
               and     AddOn, 0
               and     EditOn, 0

               mov     ecx, StrSize
              imul     ecx, 12
               mov     esi, ToolArrayM
               mov     edi, ToolArray
               rep     movsb
               mov     ArrayCnt, 13

            INVOKE     EnableWindow, hButt01, 0
            INVOKE     EnableWindow, hButt02, 0
            INVOKE     EnableWindow, hButt03, 0
            INVOKE     EnableWindow, hButt04, 0
            INVOKE     EnableWindow, hButt05, 0
            INVOKE     EnableWindow, hEdit01, 0
            INVOKE     EnableWindow, hEdit02, 0
            INVOKE     EnableWindow, hEdit03, 0
            INVOKE     SendMessage, hEdit01, WM_SETTEXT, 0, addr szNull
            INVOKE     SendMessage, hEdit02, WM_SETTEXT, 0, addr szNull
            INVOKE     SendMessage, hEdit03, WM_SETTEXT, 0, addr szNull
            INVOKE     SendMessage, hListbox2, LB_RESETCONTENT, 0, 0
              call     LoadListbox2
            INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
               mov     Cnt, eax
               mov     Incr, eax
               dec     Incr
            .while (Cnt)
               INVOKE     SendMessage, hWndTool, TB_DELETEBUTTON, Incr, 0
                  dec     Incr
                  dec     Cnt
            .endw

            TBButt     hWndTool, 0, 1001, 0
            TBButt     hWndTool, 1, 1002, 0
            TBButt     hWndTool, 2, 1003, 0
             TBSep     hWndTool
            TBButt     hWndTool, 4, 1004, 0
            TBButt     hWndTool, 5, 1005, 0
            TBButt     hWndTool, 6, 1006, 0
            TBButt     hWndTool, 7, 1007, 0
             TBSep     hWndTool
            TBButt     hWndTool, 10,1008, 0
            TBButt     hWndTool, 11,1009, 0
            TBButt     hWndTool, 12,1010, 0
            TBButt     hWndTool, 13,1011, 0
             TBSep     hWndTool
            TBButt     hWndTool, 15,1012, 0
               and     Redo, 0
            INVOKE     SendMessage, hdlg, WM_COMMAND, IDC_BSTYLESR, 0


;---------- [IDC_BCHANGEW = change width of toolbar buttons] ----------
         .elseif wparam == IDC_BCHANGEW
            INVOKE     SendMessage, hWndTool, TB_GETITEMRECT, 0, addr rect
            INVOKE     GetDlgItemInt, hToolbarDlg, IDC_ECHANGEW, 0, 0
            .if eax < 23 || eax > 100
               INVOKE     SetDlgItemInt, hdlg, IDC_ECHANGEW, 23, 0
                  mov     eax, 23
            .endif
               mov     ecx, rect.bottom
               shl     ecx, 16
               mov     cx, ax
            INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, ecx
            INVOKE     SetFocus, hStat01


;---------- [IDC_BBUILD = Extract the Toolbar information] ----------
         .elseif wparam == IDC_BBUILD
               mov     eax, offset szMenu2
               mov     mii.dwTypeData, eax
            INVOKE     SetMenuItemInfo, hMenu, 2, TRUE, addr mii
            INVOKE     DrawMenuBar, hWnd
            INVOKE     ShowWindow, hToolbarDlg, SW_HIDE
              call     Extract
         .endif
      .endif
         jmp     DlgDone

CloseIt:
      INVOKE     DeleteMenu, hMenu, 2, MF_BYPOSITION
      INVOKE     DrawMenuBar, hWnd

      INVOKE     SendMessage, hdlg, WM_COMMAND, IDC_BRESTORE, 0

         and     hData, 0
         and     hToolbarDlg, 0
         and     Incr, 0
      .while (BmpCnt)
            mov     eax, Incr
            mov     ecx, BmpArray[eax*4]
         INVOKE     DeleteObject, ecx
            inc     Incr
            dec     BmpCnt
      .endw

         and     Incr, 0
      .while (BmpCntM)
            mov     eax, Incr
            mov     ecx, BmpArrayM[eax*4]
         INVOKE     DeleteObject, ecx
            inc     Incr
            dec     BmpCntM
      .endw

      INVOKE     EndDialog, hdlg, wparam ; End the dialog with wparam as return
         mov     eax, TRUE               ; Return
         jmp     DlgRet                  ; with TRUE

DlgDone:
         mov     eax, FALSE              ; Return with FALSE
DlgRet:


         ret
ToolBarDlg ENDP

;======================================================
; Find Replace Procedure
;======================================================
FindRep PROC lpInput:DWORD, lpReplace
;LOCAL    ft:FINDTEXT
LOCAL    cr:CHARRANGE

         mov     ft.chrg.cpMin, 0
         mov     ft.chrg.cpMax, -1
         mov     eax, lpInput
         mov     ft.lpstrText, eax

FindNext:
      INVOKE     SendMessage, hREdit, EM_FINDTEXT, FR_DOWN, addr ft
      .if eax != -1
            mov     ft.chrg.cpMin, eax
            inc     ft.chrg.cpMin
            mov     cr.cpMin, eax
            mov     cr.cpMax, eax
            add     cr.cpMax, 2
         INVOKE     SendMessage, hREdit, EM_EXSETSEL, 0, addr cr
         INVOKE     SendMessage, hREdit, EM_REPLACESEL, TRUE, lpReplace
            jmp     FindNext
      .endif

         ret
FindRep ENDP

;======================================================
; Extract Toolbar information PROCEDURE
;======================================================
Extract PROC uses ebx esi edi
LOCAL    Cnt:DWORD, Incr1, Cnt1, Incr2, Cnt2, Incr3, Cnt3
LOCAL    hBitmap:DWORD, BitmapOn, StyleCnt, ID, IDOn, TextOn
LOCAL    szResc[32]:BYTE, szName[32]:BYTE, szTextTB[32]:BYTE, szTipTB[64]:BYTE
LOCAL    szWork[64]:BYTE, szBuff0[256]:BYTE, szStyles[256]:BYTE

      INVOKE     SendMessage, hListbox1, LB_GETCOUNT, 0, 0
      .if eax == LB_ERR || !eax
            ret
      .endif
         and     Incr1, 0
         mov     Cnt, eax

      INVOKE     SendMessage, hListbox2, LB_GETCOUNT, 0, 0
      .if eax == LB_ERR || !eax
            ret
      .endif
         and     Incr2, 0
         mov     Cnt2, eax

         and     ID, 0
         and     IDOn, 0
         and     TextOn, 0
         and     StyleCnt, 0
         mov     BmpID, 701
         mov     BitmapOn, 1
         mov     eax, hResr
         mov     byte ptr[eax], 0
         mov     eax, hToolStr
         mov     byte ptr[eax], 0
         mov     eax, hEquate
         mov     byte ptr[eax], 0
         mov     eax, hDefines
         mov     byte ptr[eax], 0
         mov     eax, hText
         mov     byte ptr[eax], 0
         mov     eax, hOutput
         mov     byte ptr[eax], 0

      INVOKE     IsDlgButtonChecked, hToolbarDlg, IDC_RITIMID
      .if eax
            mov     IDOn, 1
      .endif

      INVOKE     lstrcpy, hOutput, addr szToolbarRes
      INVOKE     lstrcpy, hToolTip, addr szToolbarTip

      INVOKE     lstrcpy, addr szStyles, addr szStyle
      INVOKE     IsDlgButtonChecked, hToolbarDlg, IDC_CHK01
      .if eax
            inc     StyleCnt
         INVOKE     lstrcat, addr szStyles, addr szFill
         INVOKE     lstrcat, addr szStyles, addr szFlat
      .endif
      INVOKE     IsDlgButtonChecked, hToolbarDlg, IDC_CHK03
      .if eax
         .if !StyleCnt
            INVOKE     lstrcat, addr szStyles, addr szFill
         .endif
            inc     StyleCnt
            inc     TextOn
         INVOKE     lstrcat, addr szStyles, addr szList
      .endif
      INVOKE     IsDlgButtonChecked, hToolbarDlg, IDC_CHK02
      .if eax
         .if !StyleCnt
            INVOKE     lstrcat, addr szStyles, addr szFill
         .endif
            inc     StyleCnt
         INVOKE     lstrcat, addr szStyles, addr szNoP
      .endif
      INVOKE     IsDlgButtonChecked, hToolbarDlg, IDC_CHK04
      .if eax
            and     BitmapOn, 0
            inc     TextOn
      .endif
      INVOKE     IsDlgButtonChecked, hToolbarDlg, IDC_CHK05
      .if eax
         .if !StyleCnt
            INVOKE     lstrcat, addr szStyles, addr szFill
         .endif
            inc     StyleCnt
         INVOKE     lstrcat, addr szStyles, addr szNoP
      .endif
      INVOKE     IsDlgButtonChecked, hToolbarDlg, IDC_CHK06
      .if eax
         .if !StyleCnt
            INVOKE     lstrcat, addr szStyles, addr szFill
         .endif
            inc     StyleCnt
         INVOKE     lstrcat, addr szStyles, addr szAdj
      .endif
      INVOKE     IsDlgButtonChecked, hToolbarDlg, IDC_CHK07
      .if eax
         .if !StyleCnt
            INVOKE     lstrcat, addr szStyles, addr szFill
         .endif
            inc     StyleCnt
         INVOKE     lstrcat, addr szStyles, addr szNoR
      .endif
      INVOKE     IsDlgButtonChecked, hToolbarDlg, IDC_CHK08
      .if eax
         .if !StyleCnt
            INVOKE     lstrcat, addr szStyles, addr szFill
         .endif
            inc     StyleCnt
         INVOKE     lstrcat, addr szStyles, addr szBot
      .endif
      .if StyleCnt
         INVOKE     lstrcat, addr szStyles, addr szComma
         INVOKE     lstrcat, addr szStyles, addr szSlashB
      .endif
      INVOKE     lstrcat, addr szStyles, addr szCRLF

      .while (Cnt2)
         INVOKE     SendMessage, hListbox2, LB_GETITEMDATA, Incr2, 0
            mov     hBitmap, eax
         .if eax == 1234   ; Seperator
            INVOKE     lstrcat, hToolStr, addr szTBSep
            INVOKE     lstrcat, hToolStr, addr szCRLF
               jmp     Bypass
         .endif

            and     Incr1, 0
          MOVmd     Cnt1, Cnt
         .while (Cnt1)
            INVOKE     SendMessage, hListbox1, LB_GETITEMDATA, Incr1, 0
            .if eax == hBitmap
               INVOKE     SendMessage, hListbox1, LB_GETTEXT, Incr1, addr szResc
               INVOKE     BuildR, addr szResc
                  inc     BmpID

                  mov     ecx, StrSize        ; Size of the structure
                  and     Incr3, 0
                MOVmd     Cnt3, ArrayCnt
               .while (Cnt3)
                     mov     eax, ToolArray
                     add     eax, Incr3
                     add     eax, tshBitmap
                     mov     edx, dword ptr[eax]
                  .if edx == hBitmap
                        mov     eax, ToolArray
                        add     eax, Incr3
                        mov     edx, dword ptr[eax]
                        mov     CmdID, edx
                        mov     eax, ToolArray
                        add     eax, Incr3
                        add     eax, tslpName
                        mov     edx, eax
                     INVOKE     lstrcpy, addr szName, edx
                        mov     eax, ToolArray
                        add     eax, Incr3
                        add     eax, tslpText
                        mov     edx, eax
                     INVOKE     lstrcpy, addr szTextTB, edx
                        mov     eax, ToolArray
                        add     eax, Incr3
                        add     eax, tslpTip
                        mov     edx, eax
                     INVOKE     lstrcpy, addr szTipTB, edx

                     INVOKE     lstrcat, hToolStr, addr szTBButt
                     INVOKE     lstrcat, hDefines, addr szDefine
                     .if TextOn == 2
                           mov     ID, 9999
                     .endif
                     INVOKE     wsprintf, addr szWork, addr fmat1, ID
                     INVOKE     lstrcat, hToolStr, addr szWork
                     INVOKE     lstrcat, hToolStr, addr szComma
                     INVOKE     lstrcat, hToolTip, addr szFill+15
                     .if !IDOn
                        INVOKE     lstrcat, hToolStr, addr szName
                        INVOKE     lstrcat, hToolTip, addr szName
                        INVOKE     lstrcat, hEquate, addr szName
                        INVOKE     lstrcat, hDefines, addr szName
                        INVOKE     lstrlen, addr szName
                     .else
                        INVOKE     wsprintf, addr szWork, addr fmat1, CmdID
                        INVOKE     lstrcat, hToolStr, addr szWork
                        INVOKE     lstrcat, hToolTip, addr szWork
                        INVOKE     lstrcat, hDefines, addr szWork
                        INVOKE     lstrlen, addr szName
                     .endif
                        mov     ecx, 20
                        sub     ecx, eax
                     INVOKE     lstrcpyn, addr szWork, addr szFill, ecx
                     INVOKE     lstrcat, hToolTip, addr szWork
                     INVOKE     lstrcat, hToolTip, addr szQuote
                     INVOKE     lstrcat, hToolTip, addr szTipTB
                     INVOKE     lstrcat, hToolTip, addr szQuote
                     INVOKE     lstrcat, hToolStr, addr szComma
                     INVOKE     lstrcat, hDefines, addr szWork
                     INVOKE     lstrcat, hEquate, addr szWork
                     INVOKE     lstrcat, hEquate, addr szEqu
                     INVOKE     wsprintf, addr szWork, addr fmat1, CmdID
                     INVOKE     lstrcat, hEquate, addr szWork
                     INVOKE     lstrcat, hDefines, addr szWork
                     .if !TextOn
                        INVOKE     lstrcat, hToolStr, addr szZero
                     .else
                        INVOKE     lstrcpy, addr szWork, addr szOffset
                        INVOKE     lstrcat, addr szWork, addr szSZ
                        INVOKE     lstrcat, addr szWork, addr szTextTB
                        INVOKE     lstrcat, hToolStr, addr szWork
                        INVOKE     lstrcpy, addr szWork, addr szSZ
                        INVOKE     lstrcat, addr szWork, addr szTextTB
                        INVOKE     lstrcat, hText, addr szWork
                        INVOKE     lstrlen, addr szWork
                           mov     ecx, 16
                           sub     ecx, eax
                        INVOKE     lstrcpyn, addr szWork, addr szFill, ecx
                        INVOKE     lstrcat, hText, addr szWork
                        INVOKE     lstrcat, hText, addr szDB
                        INVOKE     lstrcat, hText, addr szQuoteS
                        INVOKE     lstrcat, hText, addr szTextTB
                        INVOKE     lstrcat, hText, addr szQuoteS
                     .endif
                     INVOKE     lstrcat, hToolStr, addr szCRLF
                     INVOKE     lstrcat, hToolTip, addr szCRLF
                     INVOKE     lstrcat, hEquate, addr szCRLF
                     INVOKE     lstrcat, hDefines, addr szCRLF
                     INVOKE     lstrcat, hText, addr szCRLF
                        inc     ID
                     .break
                  .endif
                     add     Incr3, ecx
                     dec     Cnt3
               .endw

               .break
            .endif
               inc     Incr1
               dec     Cnt1
         .endw

         .if !Cnt1
DSPValue hWnd, 1111, 1, 'm'
         .endif

Bypass:
            inc     Incr2
            dec     Cnt2
      .endw

      INVOKE     lstrcat, hToolTip, addr szEnd
      INVOKE     lstrcat, hToolTip, addr szCRLF
      INVOKE     lstrcat, hToolStr, addr szCRLF
      INVOKE     lstrcat, hText, addr szCRLF
      .if !IDOn
         INVOKE     lstrcat, hOutput, hDefines
         INVOKE     lstrcat, hOutput, addr szCRLF
      .endif
      INVOKE     lstrcat, hOutput, hResr
      INVOKE     lstrcat, hOutput, addr szCRLF
      INVOKE     lstrcat, hOutput, hToolTip
      INVOKE     lstrcat, hOutput, addr szCRLF
      INVOKE     lstrcat, hOutput, addr szToolbarMac
      INVOKE     lstrcat, hOutput, hEquate
      INVOKE     lstrcat, hOutput, addr szCRLF
      INVOKE     lstrcat, hOutput, addr szCRLF
      INVOKE     lstrcat, hOutput, addr szCRLF
      INVOKE     lstrcat, hOutput, addr szToolbarDat1
      .if TextOn
         INVOKE     lstrcat, hOutput, hText
      .endif
      INVOKE     lstrcat, hOutput, addr szToolbarDat2
      INVOKE     lstrcat, hOutput, addr szWinProc
      INVOKE     lstrcat, hOutput, addr szToolbarLoc
      INVOKE     lstrcat, hOutput, addr szToolbarWnd1
      INVOKE     lstrcat, hOutput, addr szStyles
      INVOKE     lstrcat, hOutput, addr szToolbarWnd2
      INVOKE     lstrcat, hOutput, addr szToolbarCre
      INVOKE     lstrcat, hOutput, hToolStr
      INVOKE     lstrcat, hOutput, addr szToolSizTip
      INVOKE     lstrcat, hOutput, addr szToolbarDes
      INVOKE     lstrcat, hOutput, addr szChgBmpColor

      INVOKE     SendMessage, hREdit, WM_SETTEXT, 0, hOutput
      INVOKE     wsprintf, addr szWork, addr fmat1, ID
      INVOKE     FindRep, addr szNN, addr szWork
      INVOKE     GetDlgItemInt, hToolbarDlg, IDC_ECHANGEW, 0, 0
      INVOKE     wsprintf, addr szWork, addr fmat1, eax
      INVOKE     FindRep, addr szWW, addr szWork

ExtractDone:
         ret
Extract ENDP

;======================================================
; Build the resource string PROCEDURE
;======================================================
BuildR PROC uses esi edi lpName:DWORD
LOCAL    szBuff0[256]:BYTE, szResStr[256]:BYTE, szWork[10]:BYTE

         INVOKE     lstrcpy, addr szBuff0, addr szResr1
         INVOKE     lstrcat, addr szBuff0, addr szRoot  ;+2
         INVOKE     lstrcat, addr szBuff0, addr szResr2
         INVOKE     lstrcat, addr szBuff0, addr szSlashB
         INVOKE     lstrlen, addr szBuff0
            mov     ecx, eax
            lea     esi, szBuff0
            lea     edi, szResStr
         .while (ecx)
               mov     al, byte ptr[esi]
               mov     byte ptr[edi], al
            .if al == '\'
                  inc     edi
                  mov     byte ptr[edi], '\'
            .endif
               inc     esi
               inc     edi
               dec     ecx
         .endw
            mov     byte ptr[edi], 0

         INVOKE     wsprintf, addr szWork, addr fmat1, BmpID
         INVOKE     lstrcat, hResr, addr szWork
         INVOKE     lstrcat, hResr, addr szResStr
         INVOKE     lstrcat, hResr, lpName
         INVOKE     lstrcat, hResr, addr szBmp
         INVOKE     lstrcat, hResr, addr szQuote
         INVOKE     lstrcat, hResr, addr szCRLF
;INVOKE     MessageBox, NULL, hResr, addr AppName, MB_OK

         ret
BuildR ENDP

;======================================================
; Save file PROCEDURE
;======================================================
SaveFile PROC
LOCAL    ofn:OPENFILENAME
LOCAL    EditS:EDITSTREAM
LOCAL    hFile:DWORD

      INVOKE     SendMessage,  hREdit, WM_GETTEXTLENGTH, 0, 0
      .if !eax
            jmp     EndSave
      .endif

;---------- [Zero out the structures] ----------
      INVOKE     RtlZeroMemory, addr ofn, sizeof ofn
      INVOKE     RtlZeroMemory, addr EditS, sizeof EditS

      INVOKE     lstrcpy, addr PathName, addr szRoot
      INVOKE     lstrcat, addr PathName, addr szTemp

;---------- [Set the OPENFILENAME attributes] ----------
         mov     ofn.lStructSize, sizeof ofn
         mov     eax, hWnd
         mov     ofn.hwndOwner, eax
         mov     eax, hInst
         mov     ofn.hInstance, eax
         mov     ofn.lpstrFilter, offset szFilter
         mov     ofn.lpstrFile, offset PathName
         mov     ofn.nMaxFile, lengthof PathName
         mov     ofn.lpstrFileTitle, offset FileName
         mov     ofn.nMaxFileTitle, lengthof FileName
         mov     ofn.lpstrTitle, offset szSaveTitle
         mov     ofn.Flags, OFN_OVERWRITEPROMPT or OFN_CREATEPROMPT or\
                 OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST
      INVOKE     GetSaveFileName, addr ofn
      .if !eax                       ; Cancel'ed or error occurred
            mov     eax, IDCANCEL
            jmp     EndSave
      .endif

      INVOKE     CreateFile, addr PathName,\
                 GENERIC_READ or GENERIC_WRITE ,\
                 FILE_SHARE_READ or FILE_SHARE_WRITE,\
                 NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
         cmp     eax, -1             ; Error?
         jne     savcrok

saverr:
         jmp     EndSave

savcrok:
         mov     hFile, eax
         mov     EditS.dwCookie, eax
         mov     EditS.dwError, 0
         mov     EditS.pfnCallback, offset EditStreamWrite

      INVOKE     SendMessage, hREdit, EM_STREAMOUT, SF_TEXT, addr EditS
      INVOKE     CloseHandle, hFile
      INVOKE     SendMessage,  hREdit, EM_SETMODIFY, FALSE, 0

EndSave:
         ret
SaveFile ENDP

;======================================================
; Edit Stream Save Callback PROCEDURE
;======================================================
EditStreamWrite PROC  dwCookie:DWORD, pbBuff, cb, pcb
      INVOKE     WriteFile, dwCookie, pbBuff, cb, pcb, 0
         mov     eax, 0              ; File completely read
         ret
EditStreamWrite ENDP

end start